<?php 

	// Look for the wp-load.php file so we can use wordpress variables.
		$wp_include = "../wp-load.php";
		$i = 0;
		while(!file_exists($wp_include) && $i++ < 10){ $wp_include = "../$wp_include"; }
	
	require($wp_include);
	global $wpdb;
	
	require_once('forms.php');
	
	$shortcode 	= nmp_get('id');
	$wtitle 	= nmp_get('title');

	// Creates a form for the custom tinyMCE buttons
		
		function nmp_tinyMCE_form( $args ) {
		
			global $shortcode;
		
			echo '<form name="' . $shortcode . '-form" method="get" action="/" accept-charset="utf-8" >';

			// Print each option group
				
				foreach ( $args[ 'groups' ] as $group ) {
					
					if ( $group[ 'before' ] ) 
						echo $group[ 'before' ];
					
					if ( $group[ 'title' ] ) 
						echo '<h3>' . $group[ 'title' ] . '</h3>';
						
					if ( $group[ 'description' ] ) 
						echo '<p>' . $group[ 'description' ] . '</p>';			
				 
					
					// Print each field within the option group
					
					foreach ( $group[ 'fields' ] as $field ) {
						  
						// get the value of the current field.
						$formargs = get_option( $field[ 'id' ] );
							
						if ( $field['type'] == 'radio' )
							echo '<div class="nmp_radio">';
						
						switch ( $field[ 'type' ] ) {
						
							case 'text':
							  
								echo $field[ 'before' ] . '<input type="text" name="'. $field[ 'id' ] . '" id="'. $shortcode . '-' . $field[ 'id' ] .'" value="'. ( $formargs ? $formargs : $field[ 'default' ] ) . '" class="nmp_input" />' . $field[ 'after' ];
								break;
								  
							case 'textarea':
							  
								echo $field[ 'before' ] . '<textarea name="'. $field[ 'id' ] . '" id="'. $shortcode . '-' . $field[ 'id' ] .'" cols="60" rows="4" class="nmp_input" >'. ( $formargs ? $formargs : $field[ 'default' ] ) . '</textarea>' . $field[ 'after' ];
								break;
								  
							case 'select':
								
							  
								echo $field[ 'before' ] . '<select name="'. $field[ 'id' ] . '" id="'. $shortcode . '-' . $field[ 'id' ] .'" class="nmp_select">';
								foreach ( $field[ 'options' ] as $option ) {
									echo '<option value="'. $option[ 'value' ] . '" '. ( $formargs == $option[ 'value' ] ? ' selected="selected"' : '' ) . '>'. $option[ 'name' ] . '</option>';
								}
								echo '</select>' . $field[ 'after' ];
								print_r( $field[ 'after' ] );
								break;
								  
							case 'radio':
							  
								foreach ( $field['options'] as $option ) {
									echo $field[ 'before' ] . '<input type="radio" id="'. $shortcode . '-' . $field[ 'id' ] . '" name="' . $field[ 'id' ] . '" value="' . $option['value'] . '"' . ( $formargs == $option[ 'value' ] ? ' checked="checked"' : '' ) . ' /><label for="' . $field[ 'id' ] . '" class="' . $field[ 'id' ] . '">' . $option[ 'name' ] . '</label>' . $field[ 'after' ];
								}
								break;
								  
							case 'checkbox':
							  
								echo $field[ 'before' ] . '<input type="checkbox" id="'. $shortcode . '-' . $field[ 'id' ] .'" name="' . $field[ 'id' ] . '" value="' . $field[ 'value' ] . '" ' . ( $formargs == $field[ 'value' ] ? ' checked="checked"' : '' ) . ' /> ' . $field[ 'title' ] . $field[ 'after' ];
								break;
								
							case 'hidden':
							
								echo '<input type="hidden" name="'. $field[ 'id' ] . '" id="'. $shortcode . '-' . $field[ 'id' ] .'" value="'. ( $formargs ? $formargs : $field[ 'default' ] ) . '"  />';
								break;						
								  
						}
						
						if ( $field['type'] == 'radio' )
							echo '</div>';					
						  
					} // End Fields
					
					if ( $group[ 'after' ] ) 
						echo $group[ 'after' ];
					
				} // End Group
				
				echo '<a href="#submit" id="submit">' . __( 'Submit', THEMENAME) . '</a>'.
					 '<a href="#cancel" id="cancel" onclick="javascript:tinyMCEPopup.close();" />' . __( 'Cancel', THEMENAME) . '</a>'.
					 '</form>';									

		}	

?>

<!DOCTYPE html>
<html>
	<head>
		<title><?php echo $wtitle; ?></title>
		<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
		<link rel="stylesheet" type="text/css" media="all" href="<?php echo get_template_directory_uri(); ?>/css/admin/admin.css" />
		<script type="text/javascript" src="<?php echo home_url(); ?>/wp-includes/js/tinymce/tiny_mce_popup.js"></script>
		<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.js"></script>
	</head>	
	<body>

		<div class="nmp_modal">
		
			<?php
			
				switch ( $shortcode ) {
				
					case 'twitter':
						
						nmp_tinyMCE_form_twitter();
						break;

					case 'flickr':
						
						nmp_tinyMCE_form_flickr();
						break;

					case 'search':
						
						nmp_tinyMCE_form_search();
						break;

					case 'login':
						
						nmp_tinyMCE_form_login();
						break;
						
					case 'slideshow':
						
						nmp_tinyMCE_form_slideshow();
						break;
						
					case 'tooltip':
						
						nmp_tinyMCE_form_tooltip();
						break;
			
				}
			
			?>
		
		</div>
		
		<script type="text/javascript">
		
			jQuery(document).ready(function(){ 
			
				jQuery('form a#submit').click(function(event){ 
					event.preventDefault();
					ButtonDialog.insert(ButtonDialog.local_ed)
				});

				var ButtonDialog = {

					local_ed : 'ed', 
					init : function(ed){ 
					
						ButtonDialog.local_ed = ed;
						tinyMCEPopup.resizeToInnerSize();
						
					}, 
					
					insert : function insertButton(ed){ 
					
						tinyMCEPopup.execCommand('mceRemoveNode', false, null);
						
						var shortcode = '<?php echo $shortcode; ?>';

						var opts = '';

						// INPUT TYPES
						$('input[id^="' + shortcode + '-"]').each(function(index) {
							var curInputval = "";
							var curInputId  = $(this).attr('id');	
							var idArray     = curInputId.split("-");
							var idOptName   = idArray[1];
							
							switch ( $(this).attr('type') ) {											
								case 'checkbox':
									curInputval = $("#" + curInputId + ":checked").val();
								break;

								case 'radio':
									if($(this).is(':checked')) {
										curInputval = $("#" + curInputId + ":checked").val();
									}
								break;
								default:
									curInputval = $(this).val(); 
							}
							
							if (curInputval) {
								opts += ' ' + idOptName + '="' + curInputval + '"';
							}							
						});
						
						// SELECT BOX
						$('select[id^="' + shortcode + '-"]').each(function(index) {
							var curInputval = $(this).val();
							var curInputId  = $(this).attr('id');	
							var idArray     = curInputId.split("-");
							var idOptName   = idArray[1];
							
							if (curInputval) {
								opts += ' ' + idOptName + '="' + curInputval + '"';
							}
							
						});						

						// TEXTAREAS
						$('textarea[id^="' + shortcode + '-"]').each(function(index) {
							var curInputval = $(this).val();
							var curInputId  = $(this).attr('id');	
							var idArray     = curInputId.split("-");
							var idOptName   = idArray[1];
							
							if (curInputval) {
								opts += ' ' + idOptName + '="' + curInputval + '"';
							}
							
						});	
						
						var output = '[' + shortcode + ' ' + opts + ']';					

						tinyMCEPopup.execCommand('mceReplaceContent', false, output);
						tinyMCEPopup.close();

						return false;
						
					}
				};
				
				tinyMCEPopup.onInit.add(ButtonDialog.init, ButtonDialog);
				
			});
			
		</script>		
			
	

	</body>
</html>