<?php

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Tabs Wrapper: Usage: [tabs]Content here[/tabs]
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	

	add_shortcode("tabs", "tabs_shortcode");
	
	function tabs_shortcode($atts, $content = null) {
	
		$GLOBALS["tab_count"] = 0;
		
		//	Get the content
		
		do_shortcode($content);
		
		//	Generate output
		
		if (is_array( $GLOBALS["tabs"] )) {
			foreach ($GLOBALS["tabs"] as $tab) {
				$tabs[]  = '<li class="tab"><a href="#'. str_replace(" ", "-", strtolower($tab["name"])) .'">'. $tab["name"] .'</a></li>';
				$panes[] = '<div id="'. str_replace(" ", "-", strtolower($tab["name"])) .'" class="border_wrap"><p>'. do_shortcode($tab["content"]) .'</p></div>';
			}
		}
		
		$output = '<div class="tabpanel"><ul>'. implode("", $tabs) .'</ul>'. implode("", $panes) .'</div>';
		
		return $output;
		
	}
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Individual Tabs: Usage: [tab name="Tab name"]Content here[/tab]
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////		

	add_shortcode("tab", "single_tab_function");
	
	function single_tab_function($atts, $content = null) {
	
		extract(shortcode_atts(array(
			"name" => "Tab name"
		), $atts));
		
		$x = $GLOBALS["tab_count"];
		
		$GLOBALS["tabs"][$x] = array(
									"name"   => sprintf( $name, $GLOBALS["tab_count"] ),
									"content" => $content
								);
								
		$GLOBALS["tab_count"] += 1;
		
	}
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Accordian Wrapper: Usage: [accordion collapsible="true"]Content here[/accordion]
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	

	add_shortcode("accordion", "accordion_shortcode");
	
	function accordion_shortcode($atts, $content = null) {
	
		extract(shortcode_atts(array(
			"collapsible" => "false"
		), $atts));
		
		//	Check if it's collapsible
		if ($collapsible == true) {
			$collapsible = "{collapsible: true}";
		} else {
			$collapsible = "";
		}
		
		$GLOBALS["section_count"] = 0;
		
		//	Get the content
		
		do_shortcode( parse_shortcode_content( $content ) );
		
		//	Generate output
		
		if (is_array( $GLOBALS["sections"] )) {
			foreach ($GLOBALS["sections"] as $section) {
				$panes[] = '
					<li>
						<h3><a href="#'. str_replace(" ", "-", strtolower($section["name"])) .'">'. $section["name"] .'</a></h3>
						<div id="'. str_replace(" ", "-", strtolower($section["name"])) .'">
							<div class="border_wrap">'. do_shortcode( parse_shortcode_content( $section["content"] ) ) .'</div>
						</div>
					</li>';
			}
		}
		
		$output = '<ul class="accordion">'. implode("", $panes) .'</ul>';
		
		return $output;
		
	}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Accordian Section: Usage: [section name="Section name"]Content here[/section]
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////		

	add_shortcode("section", "accordion_section_function");
	
	function accordion_section_function($atts, $content = null) {
	
		extract(shortcode_atts(array(
			"name" => "Section name"
		), $atts));
		
		$x = $GLOBALS["section_count"];
		
		$GLOBALS["sections"][$x] = array(
									"name"   => sprintf( $name, $GLOBALS["section_count"] ),
									"content" => $content
								);
								
		$GLOBALS["section_count"] += 1;
		
	}