<?php

	//////////////////////////////////////////////////////////////////////////////////////////////////////	
	// Tags [tags container="unboxed" menu="" ]
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	
		function nmp_tags_sc( $atts, $content=null ) {
	
			STATIC $i = 1;
			$i++;
			
			global $post;
			
			extract( shortcode_atts( array(
				'class'				=> 'nmp_tags',
				'title'				=> NULL,
				'subtitle'			=> NULL,
				'count'				=> NMP_TAGS_COUNT,
				'order'				=> NMP_TAGS_ORDER,
				'orderby'			=> NMP_TAGS_ORDERBY,
				'mode'				=> NMP_TAGS_MODE,
				'hierarchy'			=> NMP_TAGS_HIERARCHY,				
				'taxonomy'       	=> NULL
			), $atts ) );
			
			// Display as list args...
			
				$list_args = array(
					'show_option_all'    => '',
					'orderby'            => $orderby,
					'order'              => $order,
					'show_count'         => $count,
					'hierarchical'       => $hierarchy,
					'title_li'           => '',
					'taxonomy'			 => $taxonomy,
					'walker'             => null			
				);
				
			// Display as dropdown args...
			
				$dropdown_args = array(
					'show_option_all'    => '',
					'show_option_none'   => '',
					'orderby'            => $orderby, 
					'order'              => $order,
					'show_count'         => $count,
					'hierarchical'       => $hierarchy, 
					'name'               => 'cat',
					'id'                 => '',
					'class'              => 'postform',
					'taxonomy'			 => $taxonomy,
					'walker' 			 => new nmp_dropown_walker,
					'hide_if_empty'      => false
				);
				
			// Display as tagcloud args...
			
				$tag_args = array (
					'smallest'                  => NMP_TAGS_MIN, 
					'largest'                   => NMP_TAGS_MAX,
					'unit'                      => 'pt', 
					'number'                    => 45,  
					'orderby'                   => $orderby, 
					'order'                     => $order,
					'taxonomy'                  => $taxonomy, 
					'echo'                      => true				
				);
				
			// Determine the taxonomy for the dropdown.
				
				switch ( $taxonomy ) {
					
					case 'post_tag':
					
						$d_tax = 'tag';
						break;
					
					case 'category';
						
						$d_tax = 'cat';
						break;
						
					default:
					
						$term = get_terms( $taxonomy, array( 'parent' => 0 ) );
						$d_tax = $term[0]->taxonomy;
						break;
						
				}
				


			$append = $class . '_' . $i;

			ob_start();
			
			echo '<div class="obj-links ' . $append . '">';
						

			if ( $title ) {
				
				if ( $subtitle )
					echo $title;
				else
					echo $title .'<br style="margin-bottom: 1em;" />';
				
			}
				
			if ( $subtitle )
				echo '<p class="subtitle">' . $subtitle . '</p>';

							
			// Determine the display mode...
				
				switch ( $mode ) {
					
					case 'dropdown': // Display as dropdown	
					
						echo '<form action="#">';
						wp_dropdown_categories( $dropdown_args );
						echo '</form>';	
						echo '
							<script type=\'text/javascript\'>
								/* <![CDATA[ */
									var dropdown = document.getElementById("cat");
									function onCatChange() {
										if ( dropdown.options[dropdown.selectedIndex].value != 0 ) {
											location.href = "' . home_url() . '/?' . $d_tax . '="+dropdown.options[dropdown.selectedIndex].value;
										}
									}
									dropdown.onchange = onCatChange;
								/* ]]> */
							</script>
						';
						break;
					
					case 'tagcloud': // Display as Tagcloud
					
						echo '<div class="tagcloud">';
							wp_tag_cloud( $tag_args );
						echo '</div>';
						break;
						
					case 'list': // Display as List
					
						echo '<ul class="style1">';		
							wp_list_categories( $list_args );	
						echo '</ul>';						
						break;
							
				}							

			echo '</section>';

			$nmp_shortcode = ob_get_contents();
					
			ob_end_clean();
			
			return $nmp_shortcode;

		}
		add_shortcode( 'tags', 'nmp_tags_sc' );
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Modifies the dropdown to link to use slugs instead of ids
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
		class nmp_dropown_walker extends Walker_CategoryDropdown {

			function start_el(&$output, $category, $depth, $args) {
				$pad = str_repeat('&nbsp;', $depth * 3);

				$cat_name = apply_filters('list_cats', $category->name, $category);
				$output .= "\t<option class=\"level-$depth\" value=\"".$category->slug."\"";
				if ( $category->term_id == $args['selected'] )
					$output .= ' selected="selected"';
				$output .= '>';
				$output .= $pad.$cat_name;
				if ( $args['show_count'] )
					$output .= '&nbsp;&nbsp;('. $category->count .')';

				$output .= "</option>\n";
			}
		}