<?php

	function nmp_calendar($initial = true, $echo = true) {
		global $wpdb, $m, $monthnum, $year, $wp_locale, $posts;

		$cache = array();
		
		$key = md5( $m . $monthnum . $year );
		
		if ( $cache = wp_cache_get( 'nmp_calendar', 'calendar' ) ) {
		
			if ( is_array($cache) && isset( $cache[ $key ] ) ) {
			
				if ( $echo ) {
				
					echo apply_filters( 'nmp_calendar',  $cache[$key] );
					return;
					
				} else {
				
					return apply_filters( 'nmp_calendar',  $cache[$key] );
					
				}
				
			}
			
		}

		if ( !is_array($cache) )
			$cache = array();

	// Quick check. If we have no posts at all, abort!
		
		if ( !$posts ) {
		
			$gotsome = $wpdb->get_var("SELECT 1 as test FROM $wpdb->posts WHERE post_type = 'post' AND post_status = 'publish' LIMIT 1");
			
			if ( !$gotsome ) {
			
				$cache[ $key ] = '';
				wp_cache_set( 'nmp_calendar', $cache, 'calendar' );
				return;
				
			}
			
		}

		if ( isset($_GET['w']) )
			$w = ''.intval($_GET['w']);

		// week_begins = 0 stands for Sunday
		$week_begins = intval(get_option('start_of_week'));

		// Let's figure out when we are
		
		if ( !empty($monthnum) && !empty($year) ) {
		
			$thismonth = ''.zeroise(intval($monthnum), 2);
			$thisyear = ''.intval($year);
			
		} elseif ( !empty($w) ) {
		
			// We need to get the month from MySQL
			$thisyear = ''.intval(substr($m, 0, 4));
			$d = (($w - 1) * 7) + 6; //it seems MySQL's weeks disagree with PHP's
			$thismonth = $wpdb->get_var("SELECT DATE_FORMAT((DATE_ADD('{$thisyear}0101', INTERVAL $d DAY) ), '%m')");
			
		} elseif ( !empty($m) ) {
		
			$thisyear = ''.intval(substr($m, 0, 4));
			if ( strlen($m) < 6 )
					$thismonth = '01';
			else
					$thismonth = ''.zeroise(intval(substr($m, 4, 2)), 2);
		} else {
		
			$thisyear = gmdate('Y', current_time('timestamp'));
			$thismonth = gmdate('m', current_time('timestamp'));
			
		}

		$unixmonth = mktime(0, 0 , 0, $thismonth, 1, $thisyear);
		$last_day = date('t', $unixmonth);
		
		$next_date = $thisyear . '-' . $thismonth . '-' . $last_day;
		
	// Get the next and previous month and year with at least one post
		
		$previous = $wpdb->get_row("SELECT MONTH(post_date) AS month, YEAR(post_date) AS year
			FROM $wpdb->posts
			WHERE post_date < '$thisyear-$thismonth-01'
			AND post_type = 'post' AND post_status = 'publish'
				ORDER BY post_date DESC
				LIMIT 1");
				
		$next = $wpdb->get_row("SELECT MONTH(post_date) AS month, YEAR(post_date) AS year FROM $wpdb->posts WHERE post_date > '$next_date' AND post_type = 'post' AND post_status = 'publish' ORDER BY post_date ASC LIMIT 1");
		

		/* translators: Calendar caption: 1: month name, 2: 4-digit year */
		
		$calendar_caption = _x( '%1$s %2$s', 'calendar caption', THEMENAME );
		$calendar_output = '
			<div class="row1">
				<h3 class="normal">' . sprintf($calendar_caption, $wp_locale->get_month($thismonth), date('Y', $unixmonth)) . '</h3>
		';
		
			if ( $previous ) {
			
				$calendar_output .= "\n\t\t".'<a href="' . get_month_link($previous->year, $previous->month) . '" title="' . esc_attr( sprintf(__('View posts for %1$s %2$s', THEMENAME), $wp_locale->get_month($previous->month), date('Y', mktime(0, 0 , 0, $previous->month, 1, $previous->year)))) . '" class="previous button">&lt;&lt;</a>';
			
			} 

			if ( $next ) {
			
				$calendar_output .= "\n\t\t".'<span colspan="3" id="next"><a href="' . get_month_link($next->year, $next->month) . '" title="' . esc_attr( sprintf(__('View posts for %1$s %2$s', THEMENAME), $wp_locale->get_month($next->month), date('Y', mktime(0, 0 , 0, $next->month, 1, $next->year))) ) . '" class="next button">&gt;&gt;</a>';
			
			} 		
		
		$calendar_output .= '		
			</div>		
			<div class="row2">
		';

			$myweek = array();

			for ( $wdcount=0; $wdcount<=6; $wdcount++ ) {
				$myweek[] = $wp_locale->get_weekday(($wdcount+$week_begins)%7);
			}

			foreach ( $myweek as $wd ) {
				$day_name = (true == $initial) ? $wp_locale->get_weekday_initial($wd) : $wp_locale->get_weekday_abbrev($wd);
				$wd = esc_attr($wd);
				$calendar_output .= "\n\t\t<span>$day_name</span>";
			}

		$calendar_output .= '
			</div>
			<div class="row3">
		';


		// Get days with posts
		
			$dayswithposts = $wpdb->get_results("SELECT DISTINCT DAYOFMONTH(post_date)
				FROM $wpdb->posts WHERE post_date >= '{$thisyear}-{$thismonth}-01 00:00:00'
				AND post_type = 'post' AND post_status = 'publish'
				AND post_date <= '{$thisyear}-{$thismonth}-{$last_day} 23:59:59'", ARRAY_N);
				
			if ( $dayswithposts ) {
			
				foreach ( (array) $dayswithposts as $daywith ) {
				
					$daywithpost[] = $daywith[0];
					
				}
				
			} else {
			
				$daywithpost = array();
				
			}

			if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false || stripos($_SERVER['HTTP_USER_AGENT'], 'camino') !== false || stripos($_SERVER['HTTP_USER_AGENT'], 'safari') !== false)
				$ak_title_separator = "\n";
			else
				$ak_title_separator = ', ';

			$ak_titles_for_day = array();
			
			$ak_post_titles = $wpdb->get_results("SELECT ID, post_title, DAYOFMONTH(post_date) as dom "
				."FROM $wpdb->posts "
				."WHERE post_date >= '{$thisyear}-{$thismonth}-01 00:00:00' "
				."AND post_date <= '{$thisyear}-{$thismonth}-{$last_day} 23:59:59' "
				."AND post_type = 'post' AND post_status = 'publish'"
			);
			
			if ( $ak_post_titles ) {
				foreach ( (array) $ak_post_titles as $ak_post_title ) {

						$post_title = esc_attr( apply_filters( 'the_title', $ak_post_title->post_title, $ak_post_title->ID ) );

						if ( empty($ak_titles_for_day['day_'.$ak_post_title->dom]) )
							$ak_titles_for_day['day_'.$ak_post_title->dom] = '';
						if ( empty($ak_titles_for_day["$ak_post_title->dom"]) ) // first one
							$ak_titles_for_day["$ak_post_title->dom"] = $post_title;
						else
							$ak_titles_for_day["$ak_post_title->dom"] .= $ak_title_separator . $post_title;
				}
			}

		// See how much we should pad in the beginning
		
			$pad = calendar_week_mod(date('w', $unixmonth)-$week_begins);
			
			if ( 0 != $pad )
				$calendar_output .= "\n\t\t".'<span colspan="'. esc_attr($pad) .'" class="pad">&nbsp;</span>';

			$daysinmonth = intval(date('t', $unixmonth));
			
			for ( $day = 1; $day <= $daysinmonth; ++$day ) {
			
				if ( isset($newrow) && $newrow )
					$calendar_output .= '';
				$newrow = false;

				if ( $day == gmdate('j', current_time('timestamp')) && $thismonth == gmdate('m', current_time('timestamp')) && $thisyear == gmdate('Y', current_time('timestamp')) )
					$calendar_output .= '<span id="today">';
				else
					$calendar_output .= '<span>';

				if ( in_array($day, $daywithpost) ) // any posts today?
						$calendar_output .= '<a href="' . get_day_link( $thisyear, $thismonth, $day ) . '" title="' . esc_attr( $ak_titles_for_day[ $day ] ) . "\">$day</a>";
				else
					$calendar_output .= $day;
				$calendar_output .= '</span>';

				if ( 6 == calendar_week_mod(date('w', mktime(0, 0 , 0, $thismonth, $day, $thisyear))-$week_begins) )
					$newrow = true;
					
			}

			$pad = 7 - calendar_week_mod(date('w', mktime(0, 0 , 0, $thismonth, $day, $thisyear))-$week_begins);
			
			if ( $pad != 0 && $pad != 7 )
				$calendar_output .= "\n\t\t".'<span class="x">&nbsp;</span>';

			$calendar_output .= "\n\t</div>";
			

			$cache[ $key ] = $calendar_output;
			wp_cache_set( 'nmp_calendar', $cache, 'calendar' );

			if ( $echo )
				echo apply_filters( 'nmp_calendar',  $calendar_output );
			else
				return apply_filters( 'nmp_calendar',  $calendar_output );

	}