<?php

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Theme Shortcodes
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	require_once( get_template_directory(). '/functions/shortcodes/shortcode-archive.php' );							// Archive 
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-author.php' );								// Author 
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-calendar.php' );							// Calendar
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-tags.php' );								// Categories and Tags
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-contact_form.php' );						// Contact Form
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-contact_info.php' );						// Contact Info
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-custommenu.php' );							// Custom Menu
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-flickr.php' );								// Flickr
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-google_map.php' );							// Google Map
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-jquery_ui.php' );							// Jquery Tabs and Accordian
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-links.php' );								// Links
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-loginform.php' );							// Login Form
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-pages.php' );								// Pages
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-recentcomments.php' );						// Recent Comments
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-recentposts.php' );						// Recent Posts
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-search.php' );								// Search
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-twitter.php' );							// Twitter
	require_once( get_template_directory(). '/functions/shortcodes/shortcode-video.php' );								// Video


	/*	
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// Shortcode Template [shortcode att=]
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	
		function nmp_shortcode_sc( $atts, $content=null ) {
		
			global $wp_embed;
			
			extract( shortcode_atts( array(
				'container'			=> NMP_VIDEO_CONTAINER,
				'title'				=> NULL,
				'url'				=> ''
			), $atts ) );			
			
			ob_start();
				

			// Do stuff
			
			$nmp_shortcode = ob_get_contents();
					
			ob_end_clean();
			
			return $nmp_shortcode;
			
		}
		add_shortcode( 'shortcode', 'nmp_shortcode_sc' );	
		
	*/

	
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// HTML shortcodes that didn't warrant their own file.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	

		function nmp_tooltip_sc( $atts, $content=null ) {
			extract( shortcode_atts( array(
				'title'					=> '',
				'tooltip'				=> ''
			), $atts ) );		
			$nmp_shortcode = '<span class="tooltip" title="' . $tooltip . '">' . $title . '</span>';
			return $nmp_shortcode;
		}
		add_shortcode( 'tooltip', 'nmp_tooltip_sc' );		
		
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// Dropcaps [dropcap]A[/dropcap]
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	
		function nmp_dropcap_sc( $atts, $content=null ) {
			$nmp_shortcode = '<span class="dropcap">' . parse_shortcode_content( $content ) . '</span>';
			return $nmp_shortcode;
		}
		add_shortcode( 'dropcap', 'nmp_dropcap_sc' );		

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// Quotes [quote]A[/quote]
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	
		function nmp_quote_sc( $atts, $content=null ) {
			$nmp_shortcode = '<blockquote class="big"><span class="start"></span>' . parse_shortcode_content( $content ) . '<span class="end"></span></blockquote>';
			return parse_shortcode_content(wpautop($nmp_shortcode));
		}
		add_shortcode( 'quote', 'nmp_quote_sc' );

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// Grid [grid]Lorem ipsum dolor...[/grid]
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	
		function nmp_grid_sc( $atts, $content=null ) {
			extract( shortcode_atts( array(
				'class'					=> ''
			), $atts ) );			
			$nmp_shortcode = '<div class="5grid ' . $class . '">' . parse_shortcode_content( $content ) . '</div>';
			return $nmp_shortcode;
		}
		add_shortcode( 'grid', 'nmp_grid_sc' );	

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// Grid [row]Lorem ipsum dolor...[/row]
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	
		function nmp_row_sc( $atts, $content=null ) {
			$nmp_shortcode = '<div class="row">' . parse_shortcode_content( $content ) . '</div>';
			return $nmp_shortcode;
		}
		add_shortcode( 'row', 'nmp_row_sc' );			
		
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// Grid [column]Lorem ipsum dolor...[/column]
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	
		function nmp_column_sc( $atts, $content=null ) {
			extract( shortcode_atts( array(
				'size'					=> '',
				'class'					=> ''
			), $atts ) );		
			$nmp_shortcode = '<section class="' . $size . ' ' . $class . '">' .  parse_shortcode_content( $content ) . '</section>';
			return $nmp_shortcode;
		}
		add_shortcode( 'column', 'nmp_column_sc' );

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
// Clean up nested shortcodes.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		
	function parse_shortcode_content( $content ) {

	   /* Parse nested shortcodes and add formatting. */
		$content = trim( do_shortcode(  shortcode_unautop( $content ) ) );

		///* Remove '' from the start of the string. */
		if ( substr( $content, 0, 4 ) == '' )
			$content = substr( $content, 4 );

		/* Remove '' from the end of the string. */
		if ( substr( $content, -3, 3 ) == '' )
			$content = substr( $content, 0, -3 );

		/* Remove any instances of ''. */
		$content = str_replace( array( '<p></p>' ), '', $content );
		$content = str_replace( array( '<p>  </p>' ), '', $content );

		return $content;
	}
	
	remove_filter( 'the_content', 'wpautop' );
	add_filter( 'the_content', 'wpautop' , 99);
	add_filter( 'the_content', 'shortcode_unautop', 100 );	
			
		

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
// Add shortcode buttons to the visual editor.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
	  
	function nmp_mce_button() { 
	
		if ( current_user_can( 'edit_posts' ) &&  current_user_can( 'edit_pages' ) ) {  
			add_filter('mce_external_plugins', 'nmp_mce_plugin');  
			add_filter('mce_buttons', 'nmp_mce_button_register');  
		}  
	}  
	
	add_action('init', 'nmp_mce_button');
	
	function nmp_mce_button_register( $buttons ) {  
	
		// The buttons to add
			array_push( $buttons, "|", "dropcap, quote, slideshow, tooltip" );  
		
	    return $buttons; 
		
	}  
	
	function nmp_mce_plugin( $plugin_array ) {  
		
		// Dropcaps	
			$plugin_array['dropcap'] = get_template_directory_uri() . '/functions/shortcodes/shortcode.php?id=dropcap&popup=no&title=Dropcap';	
			
		// Quotes	
			$plugin_array['quote'] = get_template_directory_uri() . '/functions/shortcodes/shortcode.php?id=quote&popup=no&title=Quote';						
			
		// Tooltip	
			$plugin_array['tooltip'] = get_template_directory_uri() . '/functions/shortcodes/shortcode.php?id=tooltip&popup=yes&title=Create a Tooltip';	
				
	   
	   return $plugin_array;  
	}
		
?>