<?php

/* Archive Widget */

class nmp_archive_widget extends WP_Widget {
  
	function nmp_archive_widget() {
		$widgets_opt = array( 'description' => __( 'A Monthly archive of your site\'s posts', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Archives', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		
		$count 							= isset($instance['nmp_archive_count']) ? (bool) $instance['nmp_archive_count'] :false;
		$dropdown 						= isset($instance['nmp_archive_dropdown']) ? (bool) $instance['nmp_archive_dropdown'] :false;

		
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			
			
			<p>
				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nmp_archive_count'); ?>" name="<?php echo $this->get_field_name('nmp_archive_count'); ?>"<?php checked( $count ); ?> />
				<label for="<?php echo $this->get_field_id('nmp_archive_count'); ?>"><?php _e( 'Show post counts', THEMENAME ); ?></label><br />

				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nmp_archive_dropdown'); ?>" name="<?php echo $this->get_field_name('nmp_archive_dropdown'); ?>"<?php checked( $dropdown ); ?> />
				<label for="<?php echo $this->get_field_id('nmp_archive_dropdown'); ?>"><?php _e( 'Show as Dropdown', THEMENAME ); ?></label>
			</p>			
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Archive Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$archiveTitle = '';
		$c = ! empty( $instance['nmp_archive_count'] ) ? '1' : '0';
		$d = ! empty( $instance['nmp_archive_dropdown'] ) ? '1' : '0';
		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $archiveTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title'] ) ) { $subTitle = esc_attr($instance['sub_title']); }  else { $subTitle = ''; }
			
		// Default values if no option set.
		
			if ( $archiveTitle == '' ) 		$archiveTitle 		= NMP_ARCHIVE_TITLE;

		
		// Clean up the title	
		
			$archiveTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $archiveTitle);
			$title = $before_title.$archiveTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[archives id="' . $args['widget_id'] . '"  title="' . $title . '" count="' . $c . '" dropdown="' . $d . '" subtitle="' . $subTitle . '"]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_archive_widget");'));

?>