<?php

/* Author Widget */

class nmp_author_widget extends WP_Widget {
  
	function nmp_author_widget() {
		$widgets_opt = array( 'description' => __( 'Display an author\'s profile.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Author', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['nmp_author_id']) ) { $author_id = esc_attr($instance['nmp_author_id']); }  else { $author_id = 1; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }

		// Author dropdown args...
		
			$args = array(
				'show_option_all'         => null, // string
				'show_option_none'        => null, // string
				'hide_if_only_one_author' => null, // string
				'orderby'                 => 'display_name',
				'order'                   => 'ASC',
				'include'                 => null, // string
				'exclude'                 => null, // string
				'multi'                   => false,
				'show'                    => 'display_name',
				'echo'                    => true,
				'selected'                => $author_id,
				'include_selected'        => false,
				'name'                    => $this->get_field_name( 'nmp_author_id' ), // string
				'id'                      => null, // integer
				'class'                   => null, // string 
				'blog_id'                 => $GLOBALS['blog_id'],
				'who'                     => null // string
			);

		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>  

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			
			
			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_author_id' ); ?>"><?php _e( 'Select an Author', THEMENAME ); ?></label>
				<?php wp_dropdown_users( $args ); ?>
			</p>	
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Author Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$authorTitle 			= '';
		$authorID 				= '';
		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $authorTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['nmp_author_id']) ) { $authorID = apply_filters('nmp_author_id',$instance['nmp_author_id']); }
			if ( isset( $instance['sub_title'] ) ) { $subTitle = esc_attr($instance['sub_title']); }  else { $subTitle = ''; }

		// Default values if no option set.
		
			if ( $authorTitle == '' ) 		$authorTitle 			= NMP_AUTHOR_TITLE;
			if ( $authorID == '' ) 			$authorID 				= 1;
		
		// Clean up the title	
		
			$authorTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $authorTitle);
			$title = $before_title.$authorTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[author id="' . $authorID . '"  title="' . $title . '" subtitle="' . $subTitle . '"]');
			echo $after_widget;
		
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_author_widget");'));

?>