<?php

/* Calendar Widget */

class nmp_calendar_widget extends WP_Widget {
  
	function nmp_calendar_widget() {
		$widgets_opt = array( 'description' => __( 'A calendar of your site\'s posts.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Calendar', THEMENAME ), $widgets_opt );
	}
	
  
	// User Options Form
	
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }

		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>   

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Calendar Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$calendarTitle 		= '';
	
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $calendarTitle = apply_filters('title',$instance['title']); } 

		// Default values if no option set.
		
			if ( $calendarTitle == '' ) 		$calendarTitle 		= NMP_CALENDAR_TITLE;
		
		// Clean up the title	
		
			$calendarTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $calendarTitle);
			$title = $before_title.$calendarTitle2.$after_title;
	
		// Print the widget

			echo do_shortcode('[calendar id="' . $args['widget_id'] . '" ]');

			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_calendar_widget");'));

?>