<?php

/* Category Widget */

class nmp_category_widget extends WP_Widget {
  
	function nmp_category_widget() {
		$widgets_opt = array( 'description' => __( 'A list or dropdown of categories.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Categories', THEMENAME ), $widgets_opt );
	}
	
  
	// User Options Form
	
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		
		$this->nmp_category_order 		= ( !empty( $instance['nmp_category_order'] ) ) ? esc_attr( $instance['nmp_category_order'] ) : '';
		$this->nmp_category_orderby 		= ( !empty( $instance['nmp_category_orderby'] ) ) ? esc_attr( $instance['nmp_category_orderby'] ) : '';
		
		$count 							= isset($instance['nmp_category_count']) ? (bool) $instance['nmp_category_count'] :false;
		$hierarchical 					= isset( $instance['nmp_category_hierarchical'] ) ? (bool) $instance['nmp_category_hierarchical'] : false;
		$dropdown 						= isset( $instance['nmp_category_dropdown'] ) ? (bool) $instance['nmp_category_dropdown'] : false;

		// Get a list of taxonomies
		
			$tnmp_args = array(
			  	  
			); 
		

		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>   
			
			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			
			
			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_category_orderby' ); ?>"><?php _e( 'Order By', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_category_orderby'); ?>" id="<?php echo $this->get_field_id('nmp_category_orderby'); ?>" class="widefat nmp_category_orderby" >
					<option value="ID" <?php if ( $this->nmp_category_orderby  == 'ID' ) { echo ' selected="selected" '; }?>><?php _e( 'ID' , THEMENAME ); ?></option>
					<option value="name" <?php if ( $this->nmp_category_orderby  == 'name' ) { echo ' selected="selected" '; }?>><?php _e( 'Name' , THEMENAME ); ?></option>
					<option value="slug" <?php if ( $this->nmp_category_orderby  == 'slug' ) { echo ' selected="selected" '; }?>><?php _e( 'Slug' , THEMENAME ); ?></option>
					<option value="count" <?php if ( $this->nmp_category_orderby  == 'count' ) { echo ' selected="selected" '; }?>><?php _e( 'Count' , THEMENAME ); ?></option>
					<option value="term_group" <?php if ( $this->nmp_category_orderby  == 'term_group' ) { echo ' selected="selected" '; }?>><?php _e( 'Term Group' , THEMENAME ); ?></option>
				</select>
			</p>			

			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_category_order' ); ?>"><?php _e( 'Order', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_category_order'); ?>" id="<?php echo $this->get_field_id('nmp_category_order'); ?>" class="widefat nmp_category_order" >
					<option value="ASC" <?php if ( $this->nmp_category_order  == 'ASC' ) { echo ' selected="selected" '; }?>><?php _e( 'Ascending' , THEMENAME ); ?></option>
					<option value="DESC" <?php if ( $this->nmp_category_order  == 'DESC' ) { echo ' selected="selected" '; }?>><?php _e( 'Descending' , THEMENAME ); ?></option>
				</select>
			</p>
						
			
			<p>
				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nmp_category_dropdown'); ?>" name="<?php echo $this->get_field_name('nmp_category_dropdown'); ?>"<?php checked( $dropdown ); ?> />
				<label for="<?php echo $this->get_field_id('nmp_category_dropdown'); ?>"><?php _e( 'Display as dropdown', THEMENAME ); ?></label><br />

				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nmp_category_count'); ?>" name="<?php echo $this->get_field_name('nmp_category_count'); ?>"<?php checked( $count ); ?> />
				<label for="<?php echo $this->get_field_id('nmp_category_count'); ?>"><?php _e( 'Show post counts', THEMENAME ); ?></label><br />

				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nmp_category_hierarchical'); ?>" name="<?php echo $this->get_field_name('nmp_category_hierarchical'); ?>"<?php checked( $hierarchical ); ?> />
				<label for="<?php echo $this->get_field_id('nmp_category_hierarchical'); ?>"><?php _e( 'Show hierarchy', THEMENAME ); ?></label>
			</p>			
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Category Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$categoryTitle 		= '';
		$categoryDropdown 	= '' ;
		$categoryCount 		= '' ;
		$categoryHierarchy 	= '' ;
		$categoryOrder 		= '' ;
		$categoryOrderby 	= '' ;

	
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $categoryTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['nmp_category_dropdown']) ) { $categoryDropdown = apply_filters('nmp_category_dropdown',$instance['nmp_category_dropdown']); }
			if ( isset( $instance['nmp_category_count']) ) { $categoryCount = apply_filters('nmp_category_count',$instance['nmp_category_count']); }
			if ( isset( $instance['nmp_category_hierarchical']) ) { $categoryHierarchy = apply_filters('nmp_category_hierarchical',$instance['nmp_category_hierarchical']); }
			if ( isset( $instance['nmp_category_order']) ) { $categoryOrder = apply_filters('nmp_category_order',$instance['nmp_category_order']); }
			if ( isset( $instance['nmp_category_orderby']) ) { $categoryOrderby = apply_filters('nmp_category_ordeby',$instance['nmp_category_orderby']); }
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			
		// Default values if no option set.
		
			if ( $categoryTitle == '' ) 		$categoryTitle 		= NMP_CATEGORY_TITLE;
			if ( $categoryCount == '' ) 		$categoryCount 		= NMP_CATEGORY_COUNT;
			if ( $categoryDropdown == '' ) 		$categoryDropdown 	= NMP_CATEGORY_DROPDOWN;
			if ( $categoryHierarchy == '' ) 	$categoryHierarchy 	= NMP_CATEGORY_HIERARCHY;
			if ( $categoryOrder == '' ) 		$categoryOrder 		= NMP_CATEGORY_ORDER;
			if ( $categoryOrderby == '' ) 		$categoryOrderby 	= NMP_CATEGORY_ORDERBY;
		
		// Clean up the title	
		
			$categoryTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $categoryTitle);
			$title = $before_title.$categoryTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[category id="' . $args['widget_id'] . '"  subtitle="' . $subTitle . '" title="' . $title . '" count="' . $categoryCount . '" dropdown="' . $categoryDropdown . '" hierarchy="' . $categoryHierarchy . '" order="' . $categoryOrder . '" orderby="' . $categoryOrderby . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_category_widget");'));

?>