<?php

/* Author Widget */

class nmp_contact_form_widget extends WP_Widget {
  
	function nmp_contact_form_widget() {
		$widgets_opt = array( 'description' => __( 'Add a contact form.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Contact Form', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
				
		
		// Show saved or default form data.
			
			if ( isset( $instance['title']) )
				$ttitle = esc_attr($instance['title']);
			else
				$ttitle = ''; 
				
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			

			if ( isset( $instance['nmp_contact_form_email']) )  
				$nmp_contact_form_email = esc_attr($instance['nmp_contact_form_email']); 
			else  
				$nmp_contact_form_email = NMP_CONTACT_FORM_EMAIL; 

			if ( isset( $instance['nmp_contact_form_dept']) )  
				$nmp_contact_form_dept = esc_attr($instance['nmp_contact_form_dept']); 
			else  
				$nmp_contact_form_dept = ''; 

			if ( isset( $instance['nmp_contact_form_subject']) )  
				$nmp_contact_form_subject = esc_attr($instance['nmp_contact_form_subject']); 
			else  
				$nmp_contact_form_subject = ''; 				
		
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 				
	
			<p>
				<label for="<?php echo $this->get_field_id('nmp_contact_form_email'); ?>"><?php _e( 'Email Address' , THEMENAME ); ?></label>
				<span class="info"><?php _e( '( comma seperated if multiple )', THEMENAME ); ?></span>
				<input id="<?php echo $this->get_field_id('nmp_contact_form_email'); ?>" name="<?php echo $this->get_field_name('nmp_contact_form_email'); ?>" type="text" class="widefat" value="<?php echo $nmp_contact_form_email; ?>" />
			</p> 

			<p>
				<label for="<?php echo $this->get_field_id('nmp_contact_form_dept'); ?>"><?php _e( 'Department' , THEMENAME ); ?></label>
				<span class="info"><?php _e( '( Department is not required if a single email is used. When using multiple emails, each entry matches the corresponding Department below. )' , THEMENAME ); ?></span>
				<input id="<?php echo $this->get_field_id('nmp_contact_form_dept'); ?>" name="<?php echo $this->get_field_name('nmp_contact_form_dept'); ?>" type="text" class="widefat" value="<?php echo $nmp_contact_form_dept; ?>" />
			</p> 			
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_contact_form_subject'); ?>"><?php _e( 'Subject' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_contact_form_subject'); ?>" name="<?php echo $this->get_field_name('nmp_contact_form_subject'); ?>" type="text" class="widefat" value="<?php echo $nmp_contact_form_subject; ?>" />
			</p> 
			
		<?php   
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Author Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$contactTitle 		 	= '';
		$contact_email 			= '';
		$contact_dept 			= '';
		$contact_subject 		= '';

		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { 						$contactTitle 		= apply_filters('title',$instance['title']); } 
			if ( isset( $instance['nmp_contact_form_email']) ) { 		$contact_email 		= apply_filters('nmp_contact_form_email',$instance['nmp_contact_form_email']); }
			if ( isset( $instance['nmp_contact_form_dept']) ) { 			$contact_dept 		= apply_filters('nmp_contact_form_dept',$instance['nmp_contact_form_dept']); }
			if ( isset( $instance['nmp_contact_form_subject']) ) { 		$contact_subject 	= apply_filters('nmp_contact_form_subject',$instance['nmp_contact_form_subject']); }
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			
		// Default values if no option set.
		
			if ( $contactTitle == '' ) 		$contactTitle = NMP_CONTACT_FORM_TITLE;
			if ( $contact_email == '' ) 	$contact_email = NMP_CONTACT_FORM_EMAIL;
			if ( $contact_subject == '' ) 	$contact_subject = NMP_CONTACT_FORM_SUBJECT;
		
		// Clean up the title	
		
			$contactTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $contactTitle);
			$title = $before_title.$contactTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[contact_form title="' . $title . '" subtitle="' . $subtitle . '" email="' . $contact_email . '" dept="' . $contact_dept . '" subject="' . $contact_subject . '"]');
			echo $after_widget;
		
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_contact_form_widget");'));

?>