<?php

/* Author Widget */

class nmp_info_widget extends WP_Widget {
  
	function nmp_info_widget() {
		$widgets_opt = array( 'description' => __( 'Share your contact info.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Contact Info', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		// Get Global Contact Info Options
		
			$nmp_info_name				= get_option( PREFIX . 'contact_info_name', 		'' );
			$nmp_info_address			= get_option( PREFIX . 'contact_info_address', 	'' );
			$nmp_info_city				= get_option( PREFIX . 'contact_info_city', 		'' );
			$nmp_info_state				= get_option( PREFIX . 'contact_info_state', 		'' );
			$nmp_info_zip				= get_option( PREFIX . 'contact_info_zip', 		'' );
			$nmp_info_country			= get_option( PREFIX . 'contact_info_country', 	'' );
			$nmp_info_phone				= get_option( PREFIX . 'contact_info_phone', 		'' );
			$nmp_info_email				= get_option( PREFIX . 'contact_info_email', 		'' );
			$nmp_info_twitter			= get_option( PREFIX . 'contact_info_twitter', 	'' );
			$nmp_info_facebook			= get_option( PREFIX . 'contact_info_facebook', 	'' );
			$nmp_info_google				= get_option( PREFIX . 'contact_info_google', 	'' );
			$nmp_info_linkedin			= get_option( PREFIX . 'contact_info_linkedin', 	'' );
			$nmp_info_pinterest			= get_option( PREFIX . 'contact_info_pinterest', 	'' );		
		
		// Show saved or default form data.

			$this->nmp_info_mode 		= ( !empty( $instance['nmp_info_mode'] ) ) ? esc_attr( $instance['nmp_info_mode'] ) : '';
			$this->nmp_info_msg 		= ( !empty( $instance['nmp_info_msg'] ) ) ? esc_attr( $instance['nmp_info_msg'] ) : '';
			
			if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
			if ( isset( $instance['nmp_info_id']) ) { $info_id = esc_attr($instance['nmp_info_id']); }  else { $info_id = 1; }	
			if ( isset( $instance['nmp_info_name']) ) { $nmp_info_name = esc_attr($instance['nmp_info_name']); }  else { $nmp_info_name = $nmp_info_name; }
			if ( isset( $instance['nmp_info_address']) ) { $nmp_info_address = esc_attr($instance['nmp_info_address']); }  else { $nmp_info_address = $nmp_info_address; }
			if ( isset( $instance['nmp_info_city']) ) { $nmp_info_city = esc_attr($instance['nmp_info_city']); }  else { $nmp_info_city = $nmp_info_city; }
			if ( isset( $instance['nmp_info_state']) ) { $nmp_info_state = esc_attr($instance['nmp_info_state']); }  else { $nmp_info_state = $nmp_info_state; }
			if ( isset( $instance['nmp_info_zip']) ) { $nmp_info_zip = esc_attr($instance['nmp_info_zip']); }  else { $nmp_info_zip = $nmp_info_zip; }
			if ( isset( $instance['nmp_info_country']) ) { $nmp_info_country = esc_attr($instance['nmp_info_country']); }  else { $nmp_info_country = $nmp_info_country; }
			if ( isset( $instance['nmp_info_email']) ) { $nmp_info_email = esc_attr($instance['nmp_info_email']); }  else { $nmp_info_email = $nmp_info_email; }
			if ( isset( $instance['nmp_info_phone']) ) { $nmp_info_phone = esc_attr($instance['nmp_info_phone']); }  else { $nmp_info_phone = $nmp_info_phone; }
			if ( isset( $instance['nmp_info_twitter']) ) { $nmp_info_twitter = esc_attr($instance['nmp_info_twitter']); }  else { $nmp_info_twitter = $nmp_info_twitter; }
			if ( isset( $instance['nmp_info_facebook']) ) { $nmp_info_facebook = esc_attr($instance['nmp_info_facebook']); }  else { $nmp_info_facebook = $nmp_info_facebook; }
			if ( isset( $instance['nmp_info_google']) ) { $nmp_info_google = esc_attr($instance['nmp_info_google']); }  else { $nmp_info_google = $nmp_info_google; }
			if ( isset( $instance['nmp_info_linkedin']) ) { $nmp_info_linkedin = esc_attr($instance['nmp_info_linkedin']); }  else { $nmp_info_linkedin = $nmp_info_linkedin; }
			if ( isset( $instance['nmp_info_pinterest']) ) { $nmp_info_pinterest = esc_attr($instance['nmp_info_pinterest']); }  else { $nmp_info_pinterest = $nmp_info_pinterest; }
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			

			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_info_mode' ); ?>"><?php _e( 'Widget Type', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_info_mode'); ?>" id="<?php echo $this->get_field_id('nmp_info_mode'); ?>" class="widefat nmp_info_mode" >
					<option value="normal" <?php if ( $this->nmp_info_mode  == 'normal' ) { echo ' selected="selected" '; }?>><?php _e( 'Normal' , THEMENAME ); ?></option>
					<option value="minimal" <?php if ( $this->nmp_info_mode  == 'minimal' ) { echo ' selected="selected" '; }?>><?php _e( 'Minimal' , THEMENAME ); ?></option>
				</select>
			</p>
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_msg'); ?>"><?php _e( 'Message' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_msg'); ?>" name="<?php echo $this->get_field_name('nmp_info_msg'); ?>" type="text" class="widefat" value="<?php echo $this->nmp_info_msg; ?>" />
			</p> 			
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_name'); ?>"><?php _e( 'Full or Company Name' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_name'); ?>" name="<?php echo $this->get_field_name('nmp_info_name'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_name; ?>" />
			</p> 	
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_address'); ?>"><?php _e( 'Street Address' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_address'); ?>" name="<?php echo $this->get_field_name('nmp_info_address'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_address; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_city'); ?>"><?php _e( 'City' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_city'); ?>" name="<?php echo $this->get_field_name('nmp_info_city'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_city; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_state'); ?>"><?php _e( 'State' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_state'); ?>" name="<?php echo $this->get_field_name('nmp_info_state'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_state; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_zip'); ?>"><?php _e( 'Postal Code' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_zip'); ?>" name="<?php echo $this->get_field_name('nmp_info_zip'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_zip; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_country'); ?>"><?php _e( 'Country' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_country'); ?>" name="<?php echo $this->get_field_name('nmp_info_country'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_country; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_phone'); ?>"><?php _e( 'Phone Number' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_phone'); ?>" name="<?php echo $this->get_field_name('nmp_info_phone'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_phone; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_email'); ?>"><?php _e( 'Email Address' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_email'); ?>" name="<?php echo $this->get_field_name('nmp_info_email'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_email; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_twitter'); ?>"><?php _e( 'Twitter Username' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_twitter'); ?>" name="<?php echo $this->get_field_name('nmp_info_twitter'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_twitter; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_facebook'); ?>"><?php _e( 'Facebook Username' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_facebook'); ?>" name="<?php echo $this->get_field_name('nmp_info_facebook'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_facebook; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_google'); ?>"><?php _e( 'Google Plus Username' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_google'); ?>" name="<?php echo $this->get_field_name('nmp_info_google'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_google; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_linkedin'); ?>"><?php _e( 'LinkedIn Profile URL' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_linkedin'); ?>" name="<?php echo $this->get_field_name('nmp_info_linkedin'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_linkedin; ?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_info_pinterest'); ?>"><?php _e( 'Pinterest Username' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_info_pinterest'); ?>" name="<?php echo $this->get_field_name('nmp_info_pinterest'); ?>" type="text" class="widefat" value="<?php echo $nmp_info_pinterest; ?>" />
			</p>			

		<?php   
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Author Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$infoTitle 		 	= '';
		$infoMode 			= '';
		$infoMsg 			= '';
		$info_name 			= '';
		$info_address 		= '';
		$info_city 			= '';
		$info_state 		= '';
		$info_zip 			= '';
		$info_country 		= '';
		$info_phone 		= '';
		$info_email 		= '';
		$info_twitter 		= '';
		$info_facebook 		= '';
		$info_google 		= '';
		$info_linkedin 		= '';
		$info_pinterest 	= '';
		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { 				$infoTitle 		= apply_filters('title',$instance['title']); } 
			if ( isset( $instance['nmp_info_mode']) ) { 			$infoMode 		= apply_filters('nmp_info_mode',$instance['nmp_info_mode']); }
			if ( isset( $instance['nmp_info_msg']) ) { 			$infoMsg 		= apply_filters('nmp_info_msg',$instance['nmp_info_msg']); }
			if ( isset( $instance['nmp_info_name']) ) { 			$info_name 		= apply_filters('nmp_info_name',$instance['nmp_info_name']); }
			if ( isset( $instance['nmp_info_address']) ) { 		$info_address 	= apply_filters('nmp_info_address',$instance['nmp_info_address']); }
			if ( isset( $instance['nmp_info_city']) ) { 			$info_city 		= apply_filters('nmp_info_city',$instance['nmp_info_city']); }
			if ( isset( $instance['nmp_info_state']) ) { 		$info_state 	= apply_filters('nmp_info_state',$instance['nmp_info_state']); }
			if ( isset( $instance['nmp_info_zip']) ) { 			$info_zip 		= apply_filters('nmp_info_zip',$instance['nmp_info_zip']); }
			if ( isset( $instance['nmp_info_country']) ) { 		$info_country 	= apply_filters('nmp_info_country',$instance['nmp_info_country']); }
			if ( isset( $instance['nmp_info_phone']) ) { 		$info_phone 	= apply_filters('nmp_info_phone',$instance['nmp_info_phone']); }
			if ( isset( $instance['nmp_info_email']) ) { 		$info_email 	= apply_filters('nmp_info_email',$instance['nmp_info_email']); }
			if ( isset( $instance['nmp_info_twitter']) ) { 		$info_twitter 	= apply_filters('nmp_info_twitter',$instance['nmp_info_twitter']); }
			if ( isset( $instance['nmp_info_facebook']) ) { 		$info_facebook 	= apply_filters('nmp_info_facebook',$instance['nmp_info_facebook']); }
			if ( isset( $instance['nmp_info_google']) ) { 		$info_google 	= apply_filters('nmp_info_google',$instance['nmp_info_google']); }
			if ( isset( $instance['nmp_info_linkedin']) ) { 		$info_linkedin 	= apply_filters('nmp_info_linkedin',$instance['nmp_info_linkedin']); }
			if ( isset( $instance['nmp_info_pinterest']) ) { 	$info_pinterest = apply_filters('nmp_info_pinterest',$instance['nmp_info_pinterest']); }			
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			
		// Default values if no option set.
		
			if ( $infoTitle == '' ) $infoTitle = NMP_INFO_TITLE;
			if ( $infoMode == '' ) $infoMode = NMP_INFO_MODE;
			if ( $infoMsg == '' ) $infoMsg = '';
		
		// Clean up the title	
		
			$infoTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $infoTitle);
			$title = $before_title.$infoTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[info 
			title="' . $title . '" 
			subtitle="' . $subtitle . '" 
			text="' . $infoMsg . '"
			mode="' . $infoMode . '"
			name="' . $info_name . '" 
			address="' . $info_address . '" 
			city="' . $info_city . '" 
			state="' . $info_state . '" 
			zip="' . $info_zip . '" 
			country="' . $info_country . '" 
			phone="' . $info_phone . '" 
			email="' . $info_email . '" 
			twitter="' . $info_twitter . '" 
			facebook="' . $info_facebook . '" 
			google="' . $info_google . '" 
			linkedin="' . $info_linkedin . '" 
			pinterest="' . $info_pinterest . '" 			
			]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_info_widget");'));

?>