<?php

/* CustomMenu Widget */

class nmp_custommenu_widget extends WP_Widget {
  
	function nmp_custommenu_widget() {
		$widgets_opt = array( 'description' => __( 'Displays your customized menus.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Custom Menu', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		
		$nav_menu = isset( $instance['nmp_custommenu_menu'] ) ? $instance['nmp_custommenu_menu'] : '';
		
		// Get menus
		
			$menus = get_terms( 'nav_menu', array( 'hide_empty' => false ) );
			
		// If no menus exists, direct the user to go and create some.
		
			if ( !$menus ) {
				echo '<p>'. sprintf( __('No menus have been created yet. <a href="%s">Create some</a>.'), admin_url('nav-menus.php') ) .'</p>';
				return;
			}			
		
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>  

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_custommenu_menu'); ?>"><?php _e('Select Menu:', THEMENAME); ?></label>
				<select id="<?php echo $this->get_field_id('nmp_custommenu_menu'); ?>" name="<?php echo $this->get_field_name('nmp_custommenu_menu'); ?>">
			<?php
				foreach ( $menus as $menu ) {
					$selected = $nav_menu == $menu->term_id ? ' selected="selected"' : '';
					echo '<option'. $selected .' value="'. $menu->term_id .'">'. $menu->name .'</option>';
				}
			?>
				</select>
			</p>			
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display CustomMenu Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$custommenuTitle = '';
		$custommenuMenu = '' ;
	
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $custommenuTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			if ( isset( $instance['nmp_custommenu_menu']) ) { $custommenuMenu = apply_filters('nmp_custommenu_menu',$instance['nmp_custommenu_menu']); }

		// Default values if no option set.
		
			if ( $custommenuTitle == '' ) 		$custommenuTitle 		= NMP_CUSTOMMENU_TITLE;
		
		// Clean up the title	
		
			$custommenuTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $custommenuTitle);
			$title = $before_title.$custommenuTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[custommenu id="' . $args['widget_id'] . '"  subtitle="' . $subtitle . '" title="' . $title . '" menu="' . $custommenuMenu . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_custommenu_widget");'));

?>