<?php

/* Twitter Widget */

class nmp_flickr_widget extends WP_Widget {
  
	function nmp_flickr_widget() {
		$widgets_opt = array( 'description' => __( 'Your Flickr feed.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Flickr', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		if ( isset( $instance['nmp_flickr_user']) ) { $tname = esc_attr($instance['nmp_flickr_user']); } else { $tname = ''; }
		if ( isset( $instance['nmp_flickr_number']) ) { $tnumber = esc_attr($instance['nmp_flickr_number']); } else { $tnumber = ''; }
		
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>  

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			
		  
			<p>
				<label for="<?php echo $this->get_field_id('nmp_flickr_user'); ?>"><?php _e( 'Flickr ID' , THEMENAME ); ?></label>
				<p><?php _e( 'If you don\'t know your Flickr ID you can find it <a href="http://idgettr.com/" target="_blank">here</a>.', THEMENAME ); ?></p>
				<input id="<?php echo $this->get_field_id('nmp_flickr_user'); ?>" name="<?php echo $this->get_field_name('nmp_flickr_user'); ?>" type="text" class="widefat" value="<?php echo $tname;?>" />
			</p> 			

			<p>
				<label for="<?php echo $this->get_field_id('nmp_flickr_number'); ?>"><?php _e( 'Number of Photos to Show' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_flickr_number'); ?>" name="<?php echo $this->get_field_name('nmp_flickr_number'); ?>" type="text" value="<?php echo $tnumber; ?>" size="3" />
			</p>
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Twitter Widget
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$flickrTitle = '';
		$flickrUser = '' ;
		$flickrNumber = '';				
		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $flickrTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			if ( isset( $instance['nmp_flickr_user']) ) { $flickrUser = apply_filters('nmp_flickr_user',$instance['nmp_flickr_user']); } 
			if ( isset( $instance['nmp_flickr_number']) ) { $flickrNumber = apply_filters('nmp_flickr_number',$instance['nmp_flickr_number']); } 

		// Default values if no option set.
		
			if ( $flickrTitle == '' ) 		$flickrTitle 		= __( NMP_FLICKR_TITLE, THEMENAME );
			if ( $flickrUser == '' ) 		$flickrUser	 		= NMP_FLICKR_USER;	
			if ( $flickrNumber == '' ) 		$flickrNumber 		= NMP_FLICKR_NUM;		
			
		// Clean up the title	
		
			$flickrTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $flickrTitle);
			$title = $before_title.$flickrTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[flickr id="' . $args['widget_id'] . '"  count="' . $flickrNumber . '" user="' . $flickrUser . '" subtitle="' . $subtitle . '" title="' . $title . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_flickr_widget");'));

?>