<?php

/* Link Widget */

class nmp_link_widget extends WP_Widget {
  
	function nmp_link_widget() {
		$widgets_opt = array( 'description' => __( 'Your blogroll', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Links', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }	
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		
		//Defaults
		
		$instance = wp_parse_args( (array) $instance, array( 
			'nmp_link_images' 		=> NMP_LINK_IMAGES, 
			'nmp_link_name' 			=> NMP_LINK_NAME, 
			'nmp_link_description' 	=> NMP_LINK_DESCRIPTION, 
			'nmp_link_rating' 		=> NMP_LINK_RATING, 
			'nmp_link_orderby' 		=> NMP_LINK_ORDERBY, 
			'nmp_link_limit' 		=> NMP_LINK_LIMIT 
		) );
		
		$link_cats = get_terms( 'link_category' );
		
		if ( ! $limit = intval( $instance['nmp_link_limit'] ) )
			$limit = -1;

		
		?>
  
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
			<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
		</p> 

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 		
			
		<p>
		
			<label for="<?php echo $this->get_field_id('nmp_link_category'); ?>"><?php _e( 'Select Link Category:', THEMENAME ); ?></label>
			<select class="widefat" id="<?php echo $this->get_field_id('nmp_link_category'); ?>" name="<?php echo $this->get_field_name('nmp_link_category'); ?>">
				<option value=""><?php _e('All Links', 'links widget', THEMENAME); ?></option>
				<?php
				foreach ( $link_cats as $link_cat ) {
					echo '<option value="' . intval($link_cat->term_id) . '"'
						. ( $link_cat->term_id == $instance['nmp_link_category'] ? ' selected="selected"' : '' )
						. '>' . $link_cat->name . "</option>\n";
				}
				?>
			</select>
		</p>
			
		<p>
			<label for="<?php echo $this->get_field_id('nmp_link_orderby'); ?>"><?php _e( 'Sort by:', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_link_orderby'); ?>" id="<?php echo $this->get_field_id('nmp_link_orderby'); ?>" class="widefat">
				<option value="name"<?php selected( $instance['nmp_link_orderby'], 'name' ); ?>><?php _e( 'Link title', THEMENAME ); ?></option>
				<option value="rating"<?php selected( $instance['nmp_link_orderby'], 'rating' ); ?>><?php _e( 'Link rating', THEMENAME ); ?></option>
				<option value="id"<?php selected( $instance['nmp_link_orderby'], 'id' ); ?>><?php _e( 'Link ID', THEMENAME ); ?></option>
				<option value="rand"<?php selected( $instance['nmp_link_orderby'], 'rand' ); ?>><?php _e( 'Random', THEMENAME ); ?></option>
			</select>
		</p>
		
		<p>
			<input class="checkbox" type="checkbox" <?php checked($instance['nmp_link_images'], true) ?> id="<?php echo $this->get_field_id('nmp_link_images'); ?>" name="<?php echo $this->get_field_name('nmp_link_images'); ?>" />
			<label for="<?php echo $this->get_field_id('nmp_link_images'); ?>"><?php _e('Show Link Image', THEMENAME); ?></label><br />
		
			<input class="checkbox" type="checkbox" <?php checked($instance['nmp_link_name'], true) ?> id="<?php echo $this->get_field_id('nmp_link_name'); ?>" name="<?php echo $this->get_field_name('nmp_link_name'); ?>" />
			<label for="<?php echo $this->get_field_id('nmp_link_name'); ?>"><?php _e('Show Link Name', THEMENAME); ?></label><br />
		
			<input class="checkbox" type="checkbox" <?php checked($instance['nmp_link_description'], true) ?> id="<?php echo $this->get_field_id('nmp_link_description'); ?>" name="<?php echo $this->get_field_name('nmp_link_description'); ?>" />
			<label for="<?php echo $this->get_field_id('nmp_link_description'); ?>"><?php _e('Show Link Description', THEMENAME); ?></label><br />
		
			<input class="checkbox" type="checkbox" <?php checked($instance['nmp_link_rating'], true) ?> id="<?php echo $this->get_field_id('nmp_link_rating'); ?>" name="<?php echo $this->get_field_name('nmp_link_rating'); ?>" />
			<label for="<?php echo $this->get_field_id('nmp_link_rating'); ?>"><?php _e('Show Link Rating', THEMENAME); ?></label>
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id('nmp_link_limit'); ?>"><?php _e( 'Number of links to show:', THEMENAME ); ?></label>
			<input id="<?php echo $this->get_field_id('nmp_link_limit'); ?>" name="<?php echo $this->get_field_name('nmp_link_limit'); ?>" type="text" value="<?php echo $limit == -1 ? '' : intval( $limit ); ?>" size="3" />
		</p>			
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Link Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$linkTitle 			= '';
		$linkDescription 	= '';
		$linkName 			= '';
		$linkRating			= '';
		$linkImages 		= '';
		$linkCategory 		= '';
		$linkOrderby 		= '';
		$linkOrder 			= $linkOrderby == 'rating' ? 'DESC' : 'ASC';
		$linkLimit 			= '';		
		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $linkTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }

		// Default values if no option set.
		
			if ( $linkTitle == '' ) 		$linkTitle 			= NMP_LINK_TITLE;
			if ( $linkDescription == '' ) 	$linkDescription 	= NMP_LINK_DESCRIPTION;
			if ( $linkName == '' ) 			$linkName 			= NMP_LINK_NAME;
			if ( $linkRating == '' ) 		$linkRating 		= NMP_LINK_RATING;
			if ( $linkImages == '' ) 		$linkImages 		= NMP_LINK_IMAGES;
			if ( $linkCategory == '' ) 		$linkCategory 		= NMP_LINK_CATEGORY;
			if ( $linkOrderby == '' ) 		$linkOrderby 		= NMP_LINK_ORDERBY;
			if ( $linkOrder == '' ) 		$linkOrder 			= $linkOrderby == 'rating' ? 'DESC' : 'ASC';
			if ( $linkLimit == '' ) 		$linkLimit 			= NMP_LINK_LIMIT;
			
		// Clean up the title	
		
			$linkTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $linkTitle);
			$title = $before_title.$linkTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[links id="' . $args['widget_id'] . '"  subtitle="' . $subtitle . '" title="' . $title . '" limit="' . $linkLimit . '" order="' . $linkOrder . '" orderby="' . $linkOrderby . '" category="' . $linkCategory . '" images="' . $linkImages . '" rating="' . $linkRating . '" name="' . $linkName . '" description="' . $linkDescription . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_link_widget");'));

?>