<?php

/* Recent Posts Widget */

class nmp_login_widget extends WP_Widget {
  
	function nmp_login_widget() {
		$widget_ops = array( 'classname' => 'nmp_login', 'description' => __( 'Allows your visitors to login or register.', THEMENAME ) );
		$this->WP_Widget( 'nmp_login', __( 'Login Form', THEMENAME ), $widget_ops );
 
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }		
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		
		?>

			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Widget Title:', THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			
		  
		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
	
  
	// Display Gallery Widget
	function widget( $args, $instance ) {
  
		global $post; 
		 extract($args, EXTR_SKIP);
		
		$loginTitle = '';			
	
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $loginTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			
		// Default values if no option set.
		
			if ( $loginTitle == '' ) 		$loginTitle 		= __( NMP_LOGIN_TITLE, THEMENAME );
		
		// Clean up the title	
		
			$loginTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $loginTitle);
			$title = $before_title.$loginTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[login id="' . $args['widget_id'] . '"  title="' . $title . '" subtitle="' . $subtitle . '"]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_login_widget");'));

?>