	var tinyMCEPreInit;
	var edCanvas;
	var wpActiveEditor;

	function ax_activate_visual_editor(id) {

		jQuery('#' + id).addClass("mceEditor");
		
		if (typeof (tinyMCE) == "object" && typeof (tinyMCE.execCommand) == "function") {
		
			ax_deactivate_visual_editor(id);
			
			if (typeof (tinyMCEPreInit.mceInit['ax_multi_widget']) == "object") {
			
				tinyMCEPreInit.mceInit[id] = tinyMCEPreInit.mceInit['ax_multi_widget'];
				tinyMCEPreInit.mceInit[id]["elements"] = id;
				
				try {
				
					tinymce.init(tinymce.extend({}, tinyMCEPreInit.mceInit['ax_multi_widget'], tinyMCEPreInit.mceInit[id]))
					
				} catch (e) {
				
					alert(e)
					
				}
				
			} else {
			
				tinyMCE.execCommand("mceAddControl", false, id)
				
			}
			
		}
		
	}

	function ax_deactivate_visual_editor(id) {

		if (typeof (tinyMCE) == "object" && typeof (tinyMCE.execCommand) == "function") {
		
			if (typeof (tinyMCE.get(id)) == "object") {
			
				content = tinyMCE.get(id).getContent();
				tinyMCE.execCommand("mceRemoveControl", false, id);
				jQuery('textarea#' + id).val(content)
				
			}
			
		}
		
	}

	function ax_open_deferred_activate_visual_editor(id) {

		jQuery('div.widget-inside:has(#' + id + ') input[id^=widget-ax_multi][id$=type][value=visual]').each(function () {
		
			if (jQuery('div.widget:has(#' + id + ') :animated')
				.size() == 0 && typeof (tinyMCE.get(id)) != "object" && jQuery('#' + id)
				.is(':visible')) {
				
				jQuery('a[id^=widget-ax_multi][id$=visual]', jQuery(this)
					.closest('div.widget-inside'))
					.click()
					
			} else if (typeof (tinyMCE.get(id)) != "object") {
			
				setTimeout(function () {
					ax_open_deferred_activate_visual_editor(id);
					id = null
				}, 100)
				
			}
			
		})
		
	}

	function ax_ajax_deferred_activate_visual_editor(id) {
		jQuery('div.widget-inside:has(#' + id + ') input[id^=widget-ax_multi][id$=type][value=visual]')
			.each(function () {
			if (jQuery.active == 0 && typeof (tinyMCE.get(id)) != "object" && jQuery('#' + id)
				.is(':visible')) {
				jQuery('a[id^=widget-ax_multi][id$=visual]', jQuery(this)
					.closest('div.widget-inside'))
					.click()
			} else if (jQuery('div.widget:has(#' + id + ') div.widget-inside')
				.is(':visible') && typeof (tinyMCE.get(id)) != "object") {
				setTimeout(function () {
					ax_ajax_deferred_activate_visual_editor(id);
					id = null
				}, 100)
			}
		})
	}
	
	jQuery(document).ready(function () {
	
		jQuery('div.widget:has(textarea[id^=widget-ax_multi]) a.widget-action').live('click', function (event) {
			event.preventDefault();
			txt_area = jQuery('textarea[id^=widget-ax_multi]', jQuery(this)
				.closest('div.widget'));
			ax_open_deferred_activate_visual_editor(txt_area.attr('id'))
		});
		
		
		jQuery(document)
			.data("events")
			.click.unshift(jQuery(document)
			.data("events")
			.click.pop());
			
		jQuery('div.widget[id*=ax_multi] input[name=savewidget]').live('click', function (event) {
		
			event.preventDefault();
			
			txt_area = jQuery('textarea[id^=widget-ax_multi]', jQuery(this).closest('div.widget'));
			
			if (typeof (tinyMCE.get(txt_area.attr('id'))) == "object") {
				ax_deactivate_visual_editor(txt_area.attr('id'))
			}
			
			jQuery(this).unbind('ajaxSuccess').ajaxSuccess(function (event, xhr, settings) {
				txt_area = jQuery('textarea[id^=widget-ax_multi]', jQuery(this).closest('div.widget-inside'));
				ax_ajax_deferred_activate_visual_editor(txt_area.attr('id'))
			})
			
		});
		
		jQuery(document)
			.data("events")
			.click.unshift(jQuery(document)
			.data("events")
			.click.pop());
			
		jQuery('a[id^=widget-ax_multi][id$=visual]').live('click', function (event) {
		
			event.preventDefault();
			jQuery('input[id^=widget-ax_multi][id$=type]', jQuery(this)
				.closest('div.widget-inside'))
				.val('visual');
			jQuery(this)
				.addClass('active');
			jQuery('a[id^=widget-ax_multi][id$=html]', jQuery(this)
				.closest('div.widget-inside'))
				.removeClass('active');
			ax_activate_visual_editor(jQuery('textarea[id^=widget-ax_multi]', jQuery(this)
				.closest('div.widget-inside'))
				.attr('id'))
				
		});
		
		jQuery('a[id^=widget-ax_multi][id$=html]').live('click', function (event) {
		
			event.preventDefault();
			jQuery('input[id^=widget-ax_multi][id$=type]', jQuery(this)
				.closest('div.widget-inside'))
				.val('html');
			jQuery(this)
				.addClass('active');
			jQuery('a[id^=widget-ax_multi][id$=visual]', jQuery(this)
				.closest('div.widget-inside'))
				.removeClass('active');
			ax_deactivate_visual_editor(jQuery('textarea[id^=widget-ax_multi]', jQuery(this)
				.closest('div.widget-inside'))
				.attr('id'))
				
		});
		
		jQuery('.editor_media_buttons a').live('click', function () {
		
			edCanvas = jQuery('textarea[id^=widget-ax_multi]', jQuery(this)
				.closest('div.widget-inside'))
				.get();
			wpActiveEditor = jQuery('textarea[id^=widget-ax_multi]', jQuery(this)
				.closest('div.widget-inside'))
				.attr('id')
				
		});
		
		if (jQuery('body.widgets_access').size() > 0) {
		
			txt_area = jQuery('textarea[id^=widget-ax_multi]');
			ax_open_deferred_activate_visual_editor(txt_area.attr('id'))
			
		}
		
	});
