<?php

/* Pages Widget */

class nmp_pages_widget extends WP_Widget {
  
	function nmp_pages_widget() {
		$widgets_opt = array( 'description' => __( 'Displays your site\'s pages.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Pages', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		if ( isset( $instance['nmp_pages_exclude']) ) { $exclude = esc_attr($instance['nmp_pages_exclude']); }  else { $exclude = ''; }

		$this->nmp_pages_sortby 		= ( !empty( $instance['nmp_pages_sortby'] ) ) ? esc_attr( $instance['nmp_pages_sortby'] ) : '';
		
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			

			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_pages_sortby' ); ?>"><?php _e( 'Sort By', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_pages_sortby'); ?>" id="<?php echo $this->get_field_id('nmp_pages_sortby'); ?>" class="widefat nmp_pages_container" >
					<option value="post_title" <?php if ( $this->nmp_pages_sortby  == 'post_title' ) { echo ' selected="selected" '; }?>><?php _e( 'Page Title' , THEMENAME ); ?></option>
					<option value="menu_order" <?php if ( $this->nmp_pages_sortby  == 'menu_order' ) { echo ' selected="selected" '; }?>><?php _e( 'Page Order' , THEMENAME ); ?></option>
				</select>
			</p>

			<p>
				<label for="<?php echo $this->get_field_id('nmp_pages_exclude'); ?>"><?php _e( 'Exclude:', THEMENAME ); ?></label> 
				<input id="<?php echo $this->get_field_id('nmp_pages_exclude'); ?>" name="<?php echo $this->get_field_name('nmp_pages_exclude'); ?>" type="text" class="widefat" value="<?php echo $exclude;?>" />
				<br />
				<small><?php _e( 'Page IDs, separated by commas.', THEMENAME ); ?></small>
			</p>			
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Pages Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$pagesTitle = '';
		$pagesSortby = '' ;
		$pagesExclude = '';		
	
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $pagesTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			if ( isset( $instance['nmp_pages_sortby']) ) { $pagesSortby = apply_filters('nmp_pages_sortby',$instance['nmp_pages_sortby']); }
			if ( isset( $instance['nmp_pages_exclude']) ) { $pagesExclude = apply_filters('nmp_pages_exclude',$instance['nmp_pages_exclude']); }

		// Default values if no option set.
		
			if ( $pagesTitle == '' ) 		$pagesTitle 	= NMP_PAGES_TITLE;
			if ( $pagesSortby == '' ) 		$pagesSortby 	= NMP_PAGES_SORTBY;
		
		// Clean up the title	
		
			$pagesTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $pagesTitle);
			$title = $before_title.$pagesTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[pages id="' . $args['widget_id'] . '"  title="' . $title . '" subtitle="' . $subtitle . '" sortby="' . $pagesSortby . '" exclude="' . $pagesExclude . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_pages_widget");'));

?>