<?php

/* Recent Comments Widget */

class nmp_comments_widget extends WP_Widget {
  
	function nmp_comments_widget() {
		$widgets_opt = array( 'description' => __( 'The most recent comments on your site.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Recent Comments', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		if ( isset( $instance['nmp_comments_number']) ) { $tnumber = esc_attr($instance['nmp_comments_number']); } else { $tnumber = ''; }

		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p> 

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			

			<p>
				<label for="<?php echo $this->get_field_id('nmp_comments_number'); ?>"><?php _e( 'Number of Comments to Show' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_comments_number'); ?>" name="<?php echo $this->get_field_name('nmp_comments_number'); ?>" type="text" value="<?php echo $tnumber; ?>" size="3" />
			</p>
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Widget
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$commentsTitle = '';
		$commentsNumber = '';				
		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $commentsTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			if ( isset( $instance['nmp_comments_number']) ) { $commentsNumber = apply_filters('nmp_comments_number',$instance['nmp_comments_number']); } 

		// Default values if no option set.
		
			if ( $commentsTitle == '' ) 		$commentsTitle 		= NMP_COMMENTS_TITLE;
			if ( $commentsNumber == '' ) 		$commentsNumber 	= NMP_COMMENTS_NUM;		
			
		// Clean up the title	
		
			$commentsTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $commentsTitle);
			$title = $before_title.$commentsTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[comments id="' . $args['widget_id'] . '"  title="' . $title . '" subtitle="' . $subtitle . '" count="' . $commentsNumber . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_comments_widget");'));

?>