<?php

/* Recent Posts Widget */

class nmp_posts_widget extends WP_Widget {
  
	function nmp_posts_widget() {
		$widgets_opt = array( 'description' => __( 'The most recent posts on your site.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Recent Posts', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		if ( isset( $instance['nmp_posts_number']) ) { $tnumber = esc_attr($instance['nmp_posts_number']); } else { $tnumber = ''; }
		
		?>
		
 			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p> 
  			
			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_posts_number'); ?>"><?php _e( 'Number of Posts to Show' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_posts_number'); ?>" name="<?php echo $this->get_field_name('nmp_posts_number'); ?>" type="text" value="<?php echo $tnumber; ?>" size="3" />
			</p>
			
			
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Widget
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$postsNumber = '';
		$postsTitle	= '';
		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $postsTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			if ( isset( $instance['nmp_posts_number']) ) { $postsNumber = apply_filters('nmp_posts_number',$instance['nmp_posts_number']); } 

		// Default values if no option set.
		
			if ( $postsTitle == '' ) 		$postsTitle 		= NMP_POSTS_TITLE;
			if ( $postsNumber == '' ) 		$postsNumber 		= NMP_POSTS_NUM;

		// Clean up the title	
		
			$postsTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $postsTitle);
			$title = $before_title.$postsTitle2.$after_title;			
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[posts id="' . $args['widget_id'] . '" title="' . $title . '" subtitle="' . $subtitle . '" count="' . $postsNumber . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_posts_widget");'));

?>