<?php

/* Search Widget */

class nmp_search_widget extends WP_Widget {
  
	function nmp_search_widget() {
		$widgets_opt = array( 'description' => __( 'Allows visitors to search your site.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Search Form', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }

		$this->nmp_search_mode 		= ( !empty( $instance['nmp_search_mode'] ) ) ? esc_attr( $instance['nmp_search_mode'] ) : '';
		
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>  

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			

			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_search_mode' ); ?>"><?php _e( 'Search Box Type', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_search_mode'); ?>" id="<?php echo $this->get_field_id('nmp_search_mode'); ?>" class="widefat nmp_search_container" >
					<option value="normal" <?php if ( $this->nmp_search_mode  == 'normal' ) { echo ' selected="selected" '; }?>><?php _e( 'Normal' , THEMENAME ); ?></option>
					<option value="minimal" <?php if ( $this->nmp_search_mode  == 'minimal' ) { echo ' selected="selected" '; }?>><?php _e( 'Minimal' , THEMENAME ); ?></option>
				</select>
			</p>
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Search Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$searchTitle = '';
		$searchMode = '' ;			
	
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $searchTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			if ( isset( $instance['nmp_search_mode']) ) { $searchMode = apply_filters('nmp_search_mode',$instance['nmp_search_mode']); }

		// Default values if no option set.
		
			if ( $searchTitle == '' ) 		$searchTitle 		= NMP_SEARCH_TITLE;
			if ( $searchMode == '' ) 		$searchMode 		= NMP_SEARCH_MODE;
		
		// Clean up the title	
		
			$searchTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $searchTitle);
			$title = $before_title.$searchTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[search id="' . $args['widget_id'] . '"  title="' . $title . '" subtitle="' . $subtitle . '" mode="' . $searchMode . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_search_widget");'));

?>