<?php

/* Tags Widget */

class nmp_tags_widget extends WP_Widget {
  
	function nmp_tags_widget() {
		$widgets_opt = array( 'description' => __( 'Lists categories, tags, and taxonomies.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Categories &amp; Tags', THEMENAME ), $widgets_opt );
	}
	
	// Get Current Taxonomy
	
	function nmp_get_current_taxonomy($instance) {
		if ( !empty($instance['nmp_tags_tax']) && taxonomy_exists($instance['nmp_tags_tax']) )
			return $instance['nmp_tags_tax'];

		return 'post_tag';
	}	
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }	
		
		$this->nmp_tags_order 			= ( !empty( $instance['nmp_tags_order'] ) ) ? esc_attr( $instance['nmp_tags_order'] ) : '';
		$this->nmp_tags_orderby 			= ( !empty( $instance['nmp_tags_orderby'] ) ) ? esc_attr( $instance['nmp_tags_orderby'] ) : '';
		$this->nmp_tags_mode 			= ( !empty( $instance['nmp_tags_mode'] ) ) ? esc_attr( $instance['nmp_tags_mode'] ) : '';
		
		$count 							= isset($instance['nmp_tags_count']) ? (bool) $instance['nmp_tags_count'] :false;
		$hierarchical 					= isset( $instance['nmp_tags_hierarchical'] ) ? (bool) $instance['nmp_tags_hierarchical'] : false;
		$dropdown 						= isset( $instance['nmp_tags_dropdown'] ) ? (bool) $instance['nmp_tags_dropdown'] : false;		
		$current_taxonomy 				= $this->nmp_get_current_taxonomy($instance);	
		
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p>   
			
			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 				

			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_tags_mode' ); ?>"><?php _e( 'Display As:', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_tags_mode'); ?>" id="<?php echo $this->get_field_id('nmp_tags_mode'); ?>" class="widefat nmp_tags_mode" >
					<option value="list" <?php if ( $this->nmp_tags_mode  == 'list' ) { echo ' selected="selected" '; }?>><?php _e( 'List' , THEMENAME ); ?></option>
					<option value="dropdown" <?php if ( $this->nmp_tags_mode  == 'dropdown' ) { echo ' selected="selected" '; }?>><?php _e( 'Dropdown' , THEMENAME ); ?></option>
					<option value="tagcloud" <?php if ( $this->nmp_tags_mode  == 'tagcloud' ) { echo ' selected="selected" '; }?>><?php _e( 'Tag Cloud' , THEMENAME ); ?></option>
				</select>
			</p>
			
			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_tags_orderby' ); ?>"><?php _e( 'Order By', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_tags_orderby'); ?>" id="<?php echo $this->get_field_id('nmp_tags_orderby'); ?>" class="widefat nmp_tags_orderby" >
					<option value="ID" <?php if ( $this->nmp_tags_orderby  == 'ID' ) { echo ' selected="selected" '; }?>><?php _e( 'ID' , THEMENAME ); ?></option>
					<option value="name" <?php if ( $this->nmp_tags_orderby  == 'name' ) { echo ' selected="selected" '; }?>><?php _e( 'Name' , THEMENAME ); ?></option>
					<option value="slug" <?php if ( $this->nmp_tags_orderby  == 'slug' ) { echo ' selected="selected" '; }?>><?php _e( 'Slug' , THEMENAME ); ?></option>
					<option value="count" <?php if ( $this->nmp_tags_orderby  == 'count' ) { echo ' selected="selected" '; }?>><?php _e( 'Count' , THEMENAME ); ?></option>
					<option value="term_group" <?php if ( $this->nmp_tags_orderby  == 'term_group' ) { echo ' selected="selected" '; }?>><?php _e( 'Term Group' , THEMENAME ); ?></option>
				</select>
			</p>			

			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_tags_order' ); ?>"><?php _e( 'Order', THEMENAME ); ?></label>
				<select name="<?php echo $this->get_field_name('nmp_tags_order'); ?>" id="<?php echo $this->get_field_id('nmp_tags_order'); ?>" class="widefat nmp_tags_order" >
					<option value="ASC" <?php if ( $this->nmp_tags_order  == 'ASC' ) { echo ' selected="selected" '; }?>><?php _e( 'Ascending' , THEMENAME ); ?></option>
					<option value="DESC" <?php if ( $this->nmp_tags_order  == 'DESC' ) { echo ' selected="selected" '; }?>><?php _e( 'Descending' , THEMENAME ); ?></option>
				</select>
			</p>			
			
			<p>
				<label for="<?php echo $this->get_field_id('nmp_tags_tax'); ?>"><?php _e( 'Select Menu:', THEMENAME ); ?></label>
				<select id="<?php echo $this->get_field_id('nmp_tags_tax'); ?>" name="<?php echo $this->get_field_name('nmp_tags_tax'); ?>">
				<?php 
					foreach ( get_taxonomies() as $taxonomy ) :
					
						$tax = get_taxonomy($taxonomy);
						
						if ( !$tax->show_tagcloud || empty($tax->labels->name) )
							continue;
							
				?>
				
					<option value="<?php echo esc_attr($taxonomy) ?>" <?php selected($taxonomy, $current_taxonomy) ?>><?php echo $tax->labels->name; ?></option>
					
				<?php endforeach; ?>
				
				</select>
			</p>	

			<p class="<?php echo $this->get_field_id('nmp_tags_hide'); ?>">
				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nmp_tags_count'); ?>" name="<?php echo $this->get_field_name('nmp_tags_count'); ?>"<?php checked( $count ); ?> />
				<label for="<?php echo $this->get_field_id('nmp_tags_count'); ?>"><?php _e( 'Show post counts', THEMENAME ); ?></label><br />

				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nmp_tags_hierarchical'); ?>" name="<?php echo $this->get_field_name('nmp_tags_hierarchical'); ?>"<?php checked( $hierarchical ); ?> />
				<label for="<?php echo $this->get_field_id('nmp_tags_hierarchical'); ?>"><?php _e( 'Show hierarchy', THEMENAME ); ?></label>
			</p>
			
			<script>
				jQuery(document).ready(function() {
				
					if(jQuery("#<?php echo $this->get_field_id('nmp_tags_mode'); ?>").find("option:selected").val() == "tagcloud") {
						jQuery(".<?php echo $this->get_field_id('nmp_tags_hide'); ?>").hide();
					}	
					
					jQuery("#<?php echo $this->get_field_id('nmp_tags_mode'); ?>").change(function() {
				   
						if(jQuery(this).find("option:selected").val() == "tagcloud") {
							jQuery(".<?php echo $this->get_field_id('nmp_tags_hide'); ?>").hide();
						}
					  
						if(jQuery(this).find("option:selected").val() != "tagcloud") {
							jQuery(".<?php echo $this->get_field_id('nmp_tags_hide'); ?>").show();
						}	
					  
					});
					
				});
			</script>			
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Tags Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$tagsTitle 		= '';
		$tagsTaxonomy 	= '';
		$tagsCount 		= '';
		$tagsHierarchy 	= '';
		$tagsOrder 		= '';
		$tagsOrderby 	= '';
		$tagsMode		= '';
	
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $tagsTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['nmp_tags_tax']) ) { $tagsTaxonomy = apply_filters('nmp_tags_tax',$instance['nmp_tags_tax']); }
			if ( isset( $instance['nmp_tags_count']) ) { $tagsCount = apply_filters('nmp_tags_count',$instance['nmp_tags_count']); }
			if ( isset( $instance['nmp_tags_hierarchical']) ) { $tagsHierarchy = apply_filters('nmp_tags_hierarchical',$instance['nmp_tags_hierarchical']); }
			if ( isset( $instance['nmp_tags_order']) ) { $tagsOrder = apply_filters('nmp_tags_order',$instance['nmp_tags_order']); }
			if ( isset( $instance['nmp_tags_orderby']) ) { $tagsOrderby = apply_filters('nmp_tags_ordeby',$instance['nmp_tags_orderby']); }
			if ( isset( $instance['nmp_tags_mode']) ) { $tagsMode = apply_filters('nmp_tags_mode',$instance['nmp_tags_mode']); }
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			
		// Default values if no option set.
		
			if ( $tagsTitle == '' ) 		$tagsTitle 		= NMP_TAGS_TITLE;
			if ( $tagsCount == '' ) 		$tagsCount 		= NMP_TAGS_COUNT;
			if ( $tagsHierarchy == '' ) 	$tagsHierarchy 	= NMP_TAGS_HIERARCHY;
			if ( $tagsOrder == '' ) 		$tagsOrder 		= NMP_TAGS_ORDER;
			if ( $tagsOrderby == '' ) 		$tagsOrderby 	= NMP_TAGS_ORDERBY;
			if ( $tagsMode == '' ) 			$tagsMode 		= NMP_TAGS_MODE;
			
		// Clean up the title	
		
			$tagsTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $tagsTitle);
			$title = $before_title.$tagsTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[tags id="' . $args['widget_id'] . '"  subtitle="' . $subtitle . '" title="' . $title . '" count="' . $tagsCount . '" hierarchy="' . $tagsHierarchy . '" order="' . $tagsOrder . '" orderby="' . $tagsOrderby . '" mode="' . $tagsMode . '" taxonomy="' . $tagsTaxonomy . '" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_tags_widget");'));

?>