<?php

/* Twitter Widget */

class nmp_tweet_widget extends WP_Widget {
  
	function nmp_tweet_widget() {
		$widgets_opt = array( 'description' => __( 'Your Twitter Feed.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Twitter', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;

		if ( isset( $instance['nmp_tweet_user']) ) { $tname = esc_attr($instance['nmp_tweet_user']); } else { $tname = ''; }
		if ( isset( $instance['nmp_tweet_number']) ) { $tnumber = esc_attr($instance['nmp_tweet_number']); } else { $tnumber = ''; }
		if ( isset( $instance['nmp_tweet_avatar']) ) { $tavatar = esc_attr($instance['nmp_tweet_avatar']); } else { $tavatar = ''; }
		
		?>
		  
			<p>
				<label for="<?php echo $this->get_field_id('nmp_tweet_user'); ?>"><?php _e( 'Twitter Username' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_tweet_user'); ?>" name="<?php echo $this->get_field_name('nmp_tweet_user'); ?>" type="text" class="widefat" value="<?php echo $tname;?>" />
			</p>  			

			<p>
				<label for="<?php echo $this->get_field_id('nmp_tweet_number'); ?>"><?php _e( 'Number of Tweets to Show' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_tweet_number'); ?>" name="<?php echo $this->get_field_name('nmp_tweet_number'); ?>" type="text" value="<?php echo $tnumber; ?>" size="3" />
			</p>
			
			<p>	
				<input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('nmp_tweet_avatar'); ?>" name="<?php echo $this->get_field_name('nmp_tweet_avatar'); ?>"  value="true" <?php if ( !empty( $tavatar )  ) { echo 'checked="checked"'; } ?> />
				<label for="<?php echo $this->get_field_id('nmp_tweet_avatar'); ?>"><?php _e( 'Display Avatars' , THEMENAME ); ?></label><br />
			</p>	

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Twitter Widget
	function widget( $args, $instance ) {
  
		global $post; 
		
		extract($args);

		$tweetUser = '' ;
		$tweetNumber = '';		
		$tweetAvatar = '';		
		
		// Options set in the widget control panel
 
			if ( isset( $instance['nmp_tweet_user']) ) { $tweetUser = apply_filters('nmp_tweet_user',$instance['nmp_tweet_user']); } 
			if ( isset( $instance['nmp_tweet_number']) ) { $tweetNumber = apply_filters('nmp_tweet_number',$instance['nmp_tweet_number']); } 
			if ( isset( $instance['nmp_tweet_avatar']) ) { $tweetAvatar = apply_filters('nmp_tweet_avatar',$instance['nmp_tweet_avatar']); }
			
		// Default values if no option set.

			if ( $tweetUser == '' ) 		$tweetUser	 		= NMP_TWITTER_USER;	
			if ( $tweetNumber == '' ) 		$tweetNumber 		= NMP_TWITTER_NUM;		
			if ( $tweetAvatar == '' ) 		$tweetAvatar 		= NMP_TWITTER_AVATAR;
		
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[twitter count="' . $tweetNumber . '" avatar="' . $tweetAvatar . '" user="' . $tweetUser . '" icon_size="mini" ]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_tweet_widget");'));

?>