<?php

/* Video Widget */

class nmp_video_widget extends WP_Widget {
  
	function nmp_video_widget() {
		$widgets_opt = array( 'description' => __( 'Displays videos.', THEMENAME ) );
		parent::WP_Widget( false, $name= __( 'Video', THEMENAME ), $widgets_opt );
	}
  
	// User Options Form
	function form($instance) {
  
		global $post;
		
		if ( isset( $instance['title']) ) { $ttitle = esc_attr($instance['title']); }  else { $ttitle = ''; }
		if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
		if ( isset( $instance['nmp_video_url']) ) { $video_url = esc_attr($instance['nmp_video_url']); }  else { $video_url = ''; }
		
		?>
  
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e( 'Widget Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" class="widefat" value="<?php echo $ttitle;?>" />
			</p> 

			<p>
				<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e( 'Widget Sub Title' , THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>" type="text" class="widefat" value="<?php echo $subtitle;?>" />
			</p> 			
			
			<p>
				<label for="<?php echo $this->get_field_id( 'nmp_video_url' ); ?>"><?php _e( 'Video URL', THEMENAME ); ?></label>
				<input id="<?php echo $this->get_field_id('nmp_video_url'); ?>" name="<?php echo $this->get_field_name('nmp_video_url'); ?>" type="text" class="widefat" value="<?php echo $video_url;?>" />
			</p>	
				

		<?php    
	} 
  
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
  
	// Display Video Widget
	
	function widget( $args, $instance ) {
  
		global $post; 
		extract($args);
		
		$videoTitle 			= '';
		$videoURL 				= '';
		
		// Options set in the widget control panel
		
			if ( isset( $instance['title']) ) { $videoTitle = apply_filters('title',$instance['title']); } 
			if ( isset( $instance['sub_title']) ) { $subtitle = esc_attr($instance['sub_title']); }  else { $subtitle = ''; }
			if ( isset( $instance['nmp_video_url']) ) { $videoURL = apply_filters('nmp_video_url',$instance['nmp_video_url']); }

		// Default values if no option set.
		
			if ( $videoTitle == '' ) 		$videoTitle 			= NMP_VIDEO_TITLE;
		
		// Clean up the title	
		
			$videoTitle2 = preg_replace('/(^[A-z0-9_]+)\s/i', '$1 ', $videoTitle);
			$title = $before_title.$videoTitle2.$after_title;
	
		// Print the widget
			
			echo $before_widget;
			echo do_shortcode('[video url="' . $videoURL . '"  title="' . $title . '" subtitle="' . $subtitle . '"]');
			echo $after_widget;
			
	} 
  
}

add_action('widgets_init', create_function('', 'return register_widget("nmp_video_widget");'));

?>