/*
	Flickipino: Shows your flickr photos
	By Hillipino | http://hillipino.com/
	Dual licensed under the MIT or GPL license.
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	MIT LICENSE:
	Copyright (c) 2010 nodethirtythree design, http://nodethirtythree.com/
	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use,
	copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following conditions:
	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	GPL LICENSE:
	Copyright (c) 2010 nodethirtythree design, http://nodethirtythree.com/
	This program is free software: you can redistribute it and/or modify it	under the terms of the GNU General Public License as
	published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version. This program is
	distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
	or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of
	the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>. 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
*/

(function($) {

	jQuery.fn.flickipino = function(options) {

		// Settings

			var settings = jQuery.extend({
					flkAppend:							'nmp_flickr',		// Class to load photos into.
					flkUser:							'25664079@N05',		// The flickr user to fetch.
					flkCount:							11					// Amount of photos to show.
			}, options);
			

			function initialize() {
			
				var x = settings;
				
				var count = x.flkCount-1;
				
				$.getJSON("http://api.flickr.com/services/feeds/photos_public.gne?id=" + x.flkUser + "&lang=en-us&format=json&jsoncallback=?", function(data){
				
					$.each(data.items, function(i,item){
					
						$("<img/>").attr("src", item.media.m).appendTo('#' + x.flkAppend).wrap("<a class='image image-fit' href='" + item.link + "'></a>");
						
						if ( i == count ) return false;

					});
					
					var size  = 3,
						$imgs = $('#'+x.flkAppend+' > a' ),
						curHtml = null,
						colNum  = 0,
						colArray = new Array(size),
						i = 0;

					$imgs.each(function(i,item){
						colNum = colNum + 1;
						curHtml = $('<div>').append( $(this).clone() ).html();
						colArray[colNum] = (colArray[colNum]) ? colArray[colNum] + curHtml : curHtml;
						if (colNum == size) {
							colNum = 0;
						}
					});
					
					$("#"+x.flkAppend).empty();
					var colHtml = null;
					
					for (i = 1; i < size + 1; i++) {
						colHtml = '<div class="do-4u">' + colArray[i] + '</div>';
						$("#"+x.flkAppend).append(colHtml);
					}					
					
				});					

			
			}

		// Ready
			jQuery().ready(function() {
					initialize();
			});			
		
	};

})(jQuery);



