/*
	Twittipino: Shows tweets duh!
	By Hillipino | http://hillipino.com/
	Dual licensed under the MIT or GPL license.
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	MIT LICENSE:
	Copyright (c) 2010 nodethirtythree design, http://nodethirtythree.com/
	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use,
	copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following conditions:
	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	GPL LICENSE:
	Copyright (c) 2010 nodethirtythree design, http://nodethirtythree.com/
	This program is free software: you can redistribute it and/or modify it	under the terms of the GNU General Public License as
	published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version. This program is
	distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
	or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of
	the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>. 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
*/

(function($) {

	jQuery.fn.twittipino = function(options) {

		// Settings

			var settings = jQuery.extend({
					twtAppend:							'.tweets',			// Class to append tweets to.
					twtAvatar:							true,				// Shows the Avatar beside tweets.
					twtUser:							'4templates',		// The twitter user to fetch.
					twtCount:							5					// Amount of tweets to show.
			}, options);
			

			function initialize() {
			
				var x = settings;
				
				$.ajax({
						url: 'http://api.twitter.com/1/statuses/user_timeline.json/',
						type: 'GET',
						dataType: 'jsonp',
						data: {
							screen_name: x.twtUser,
							include_rts: true,
							count: x.twtCount,
							include_entities: true
						},
						success: function(data, textStatus, xhr) {
						
						if ( !x.twtAvatar ) 
							var avatar = 'style="display: none"';
							
						var html = '\
							<article>\
								<p>TWEET_TEXT</p>\
								<span class="date">AGO</span>\
								<span class="reply">\
									<a href="http://twitter.com/intent/tweet?in_reply_to=ID" class="twtr-reply">reply</a> - <a href="http://twitter.com/intent/retweet?tweet_id=ID" class="twtr-retweet">retweet</a> - <a href="http://twitter.com/intent/favorite?tweet_id=ID" class="twtr_favorite">favorite</a>\
								</span>\
							</article>\
						';

						// append tweets into page
						for (var i = 0; i < data.length; i++) {
						
							$(x.twtAppend).append(
									html.replace('TWEET_TEXT', clean(data[i].text))
										.replace(/USER/g, data[i].user.screen_name)
										.replace('AGO', timeAgo(data[i].created_at))
										.replace(/ID/g, data[i].id_str)
							);

						}

					}					

				}); 
			}
			
			
			
			/* relative time calculator FROM TWITTER                                                               */
			/* @param {string} twitter date string returned from Twitter API                                       */
			/* @return {string} relative time like "2 minutes ago"                                                 */
			  
				function timeAgo(dateString) {
				
					var rightNow = new Date();
					var then = new Date(dateString);
					
					if ($.browser.msie) {
						// IE can't parse these crazy Ruby dates
						then = Date.parse(dateString.replace(/( \+)/, ' UTC$1'));
					}

					var diff = rightNow - then;

					var second = 1000,
					minute = second * 60,
					hour = minute * 60,
					day = hour * 24,
					week = day * 7;

					if (isNaN(diff) || diff < 0) {
						return ""; // return blank string if unknown
					}

					if (diff < second * 2) {
						// within 2 seconds
						return "right now";
					}

					if (diff < minute) {
						return Math.floor(diff / second) + " seconds ago";
					}

					if (diff < minute * 2) {
						return "about 1 minute ago";
					}

					if (diff < hour) {
						return Math.floor(diff / minute) + " minutes ago";
					}

					if (diff < hour * 2) {
						return "about 1 hour ago";
					}

					if (diff < day) {
						return  Math.floor(diff / hour) + " hours ago";
					}

					if (diff > day && diff < day * 2) {
						return "yesterday";
					}

					if (diff < day * 365) {
						return Math.floor(diff / day) + " days ago";
					}

					else {
						return "over a year ago";
					}
					
				}
    
	
			
			/* The Twitalinkahashifyer!                                                                            */
			/* http://www.dustindiaz.com/basement/ify.html                                                         */
			

				link = function(tweet) {
					return tweet.replace(/\b(((https*\:\/\/)|www\.)[^\"\']+?)(([!?,.\)]+)?(\s|$))/g, function(link, m1, m2, m3, m4) {
						var http = m2.match(/w/) ? 'http://' : '';
						return '<a class="twtr-hyperlink" target="_blank" href="' + http + m1 + '">' + ((m1.length > 25) ? m1.substr(0, 24) + '...' : m1) + '</a>' + m4;
					});
				}

				at = function(tweet) {
					return tweet.replace(/\B[@@]([a-zA-Z0-9_]{1,20})/g, function(m, username) {
						return '<a target="_blank" class="twtr-atreply" href="http://twitter.com/intent/user?screen_name=' + username + '">@' + username + '</a>';
					});
				}

				list = function(tweet) {
					return tweet.replace(/\B[@@]([a-zA-Z0-9_]{1,20}\/\w+)/g, function(m, userlist) {
						return '<a target="_blank" class="twtr-atreply" href="http://twitter.com/' + userlist + '">@' + userlist + '</a>';
					});
				}

				hash = function(tweet) {
					return tweet.replace(/(^|\s+)#(\w+)/gi, function(m, before, hash) {
						return before + '<a target="_blank" class="twtr-hashtag" href="http://twitter.com/search?q=%23' + hash + '">#' + hash + '</a>';
					});
				}

				clean = function(tweet) {
					return this.hash(this.at(this.list(this.link(tweet))));
				}

		// Ready
			jQuery().ready(function() {
					initialize();
			});			
		
	};

})(jQuery);



