/*
	Tiptrox 0.1 (EXPERIMENTAL): Does customizable tooltips and stuff.
	By nodethirtythree design | http://nodethirtythree.com/ | @nodethirtythree
	Dual licensed under the MIT or GPLv2 license.
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	MIT LICENSE:
	Copyright (c) 2012 nodethirtythree design, http://nodethirtythree.com/
	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use,
	copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following conditions:
	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	GPLv2 LICENSE:
	Copyright (c) 2012 nodethirtythree design, http://nodethirtythree.com/
	This program is free software: you can redistribute it and/or modify it	under the terms of the GNU General Public License as
	published by the Free Software Foundation, either version 2 of the License, or (at your option) any later version. This program is
	distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
	or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of
	the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>. 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
*/

(function(jQuery) {

	jQuery.fn.tiptrox = function(options) {
		var settings = jQuery.extend({
			selectorParent:		jQuery(this)
		}, options);
		return jQuery.tiptrox(settings);
	}

	jQuery.tiptrox = function(options) {
		// Settings
			var settings = jQuery.extend({
				selectorParent: 	null,
				baseZIndex:			1000,
				hotspotSelector:	null,
				follow:				true,
				ypos:				'top',
				xpos:				'center',
				xpad:				0,
				ypad:				20,
				bottomLeftClass:	'tiptrox-bottom-left',
				bottomRightClass:	'tiptrox-bottom-right',
				bottomCenterClass:	'tiptrox-bottom-center',
				topLeftClass:		'tiptrox-top-left',
				topRightClass:		'tiptrox-top-right',
				topCenterClass:		'tiptrox-top-center',
				delay:				250,
				cursor:				'help'
			}, options);

		settings.selectorParent.each(function() {
			// Vars
				var timeoutID, p = jQuery(this), q, cy = settings.ypos, cx = settings.xpos;
				var _mobile = (navigator.userAgent.search(/(iOS|iPhone|iPad|Android)/) != -1);
				q = jQuery('<span class="tiptrox">' + p.attr('title') + '<span class="arrow"></span></span>').insertAfter(p);
				p.attr('title', '');
				q.css('z-index', settings.baseZIndex);
			// Main
				function getLeft(offset)
				{
					switch (settings.xpos)
					{
						case 'center':
							cx = 'Center';
							if (offset <= q.outerWidth() + 5) {
								cx = 'Right';
								return Math.min(jQuery(window).width() - q.outerWidth(), offset + settings.xpad);
							}
							else if (offset >= jQuery(window).width() - q.outerWidth() - 5) {
								cx = 'Left';
								return Math.max(0, offset - q.outerWidth() - settings.xpad);
							}
							return Math.min(Math.max(0, offset - (q.outerWidth() / 2) + 1), jQuery(window).width() - q.outerWidth());
						case 'left':
							cx = 'Left';
							if (offset <= q.outerWidth() + 5) {
								cx = 'Right';
								return Math.min(jQuery(window).width() - q.outerWidth(), offset + settings.xpad);
							}
							return Math.max(0, offset - q.outerWidth() - settings.xpad);
						case 'right':
							cx = 'Right';
							if (offset >= jQuery(window).width() - q.outerWidth() - 5) {
								cx = 'Left';
								return Math.max(0, offset - q.outerWidth() - settings.xpad);
							}
							return Math.min(jQuery(window).width() - q.outerWidth(), offset + settings.xpad);
					}
							
					return offset;
				}
				
				function getTop(offset)
				{
					var n;
					switch (settings.ypos)
					{
						case 'top':
							n = offset - q.outerHeight() - settings.ypad;
							cy = 'top';
							if (n > 0)
								return n;
						case 'bottom':
							if (offset + q.outerHeight() >= jQuery(window).height() - settings.ypad) {
								cy = 'top';
								return offset - q.outerHeight() - settings.ypad;
							}
							cy = 'bottom';
							return Math.min(jQuery(window).height() - q.outerHeight(), offset + settings.ypad);
					}
					
					return offset;
				}
				
				var t;
				
				q.
					bind('turnon', function() {
						q.fadeIn(200);
					}).
					bind('turnoff', function() {
						q.hide();
					}).
					hide().
					css('position', 'fixed');
				p.
					bind('turnoff', function() {
						window.clearTimeout(timeoutID);
						q.trigger('turnoff');
					}).
					css('cursor', settings.cursor).
					mousemove(function(event) {
						if (settings.follow) {
							eval('t = settings.' + cy + cx + 'Class;');
							if (t)
								q.removeClass(t);
							q.css('top', getTop(event.clientY)).css('left', getLeft(event.clientX, true));
							eval('t = settings.' + cy + cx + 'Class;');
							q.addClass(t);
						}
					}).
					mouseenter(function(event) {
						if (settings.delay == 0)
							q.trigger('turnon');
						else
							timeoutID = window.setTimeout(function() {
								q.trigger('turnon');
							}, settings.delay);
					}).
					mouseleave(function() {
						window.clearTimeout(timeoutID);
						q.trigger('turnoff');
					});
					
				if (_mobile) {
					p.click(function(event) {
						if (q.is(':visible')) {
							window.clearTimeout(timeoutID);
							q.trigger('turnoff');
						}
					});
					q.click(function(event) {
						window.clearTimeout(timeoutID);
						q.trigger('turnoff');
					});
				}
		});
	}

})(jQuery);